//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#include <vcl\printers.hpp>
#include <vcl\registry.hpp>
#include <vcl\classes.hpp>
#include <vcl\sysutils.hpp>
#include <vcl\system.hpp>
#include <winresrc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <dir.h>
#include <dos.h>
#include <io.h>
#include <sys\stat.h>
#include <math.h>
#include <win32\shellapi.h>
#include <win32\winbase.h>
#include <win32\winuser.h>
#pragma hdrstop

#include "ImageKit.h"
#include "ImgkDef.h"

#include "MdiView.h"
#include "MdiFrame.h"
#include "MdiPreview.h"
#include "Wall.h"
#include "Timer.h"
#include "DeRe.h"
#include "SaveFile.h"
#include "PrintRatio.h"
#include "Text.h"
#include "DirectoryList.h"
#include "MdiList.h"
#include "Contrast.h"
#include "Bright.h"
#include "Blank.h"
#include "RGB.h"
#include "Reduce.h"
#include "Triming.h"
#include "OverView.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TViewForm *ViewForm;
const AnsiString DefaultFileName = "Untitled";
//---------------------------------------------------------------------------
__fastcall TViewForm::TViewForm(TComponent* Owner)
	: TForm(Owner)
{
	PathName = DefaultFileName;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Exit1Click(TObject *Sender)
{
	FrameForm->Exit1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Close1Click(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Open1Click(TObject *Sender)
{
	FrameForm->Open1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Open(const AnsiString FileName)
{
    bool stretch;
    bool ft;
    int  count;
    int  width, height;
    Graphics::TBitmap *bitmap;
    UINT bufsize;
    LPBYTE buf;
    AnsiString LoadName;
    AnsiString LoadType;
    AnsiString Ext;
    AnsiString ShortName;
    TIcon *icon;
    HMETAFILE hMetaFile;
    HENHMETAFILE hEnhMetaFile;
    ENHMETAHEADER EnhMetaHeader;
    SHFILEINFO shfi;
    DWORD ilist;
    RECT rect;
    HANDLE handle;
    FILE_INFO FT;
    WIN32_FIND_DATA ffd;
    DWORD size;

    stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;

	PathName = FileName;
    Caption = ExtractFileName(PathName);
    Ext = ExtractFileExt(FileName);
    Ext = Ext.UpperCase();

    ft = false;

    if (Ext == ".BMP" || Ext == ".RLE") {
        bitmap = new Graphics::TBitmap;

        ft = true;
        try {
    		bitmap->LoadFromFile(PathName);
        }
        catch(...) {
        	ft = false;
        }

        if (ft) {
        	Image1->Picture->Bitmap->Width = bitmap->Width;
        	Image1->Picture->Bitmap->Height = bitmap->Height;

            Image1->Picture->Bitmap->Canvas->StretchDraw(Rect(0, 0,
             bitmap->Width, bitmap->Height), bitmap);

            Image1->Width = bitmap->Width;
            Image1->Height = bitmap->Height;
        }

        delete bitmap;
    }
    else if (Ext == ".JPG" || Ext == ".TIF") {
        ft = true;
        try {
        	ft = ImgKitFileType(PathName.c_str(), &FT);
        }
        catch(...) {
        	ft = false;
        }

        if (ft) {
        	LoadName = "Loading " + ExtractFileName(PathName);
            if (Ext == ".JPG")
            	LoadType = "JPEG";
            else
            	LoadType = "TIFF";

            try {
        		handle = ImgKitFileLoad(PathName.c_str(), LoadName.c_str(), LoadType.c_str());
            }
            catch(...) {
            	handle = 0;
            }

        	if (handle != 0) {
                try {
        			Image1->Width = FT.Width;
        			Image1->Height = FT.Height;

        			Image1->Picture->Bitmap->Width = FT.Width;
        			Image1->Picture->Bitmap->Height = FT.Height;

        			ImgKitDisplayHdc(Image1->Canvas->Handle, handle, FT.Width, FT.Height, false);
        			ImgKitMemFree(handle);
                }
                catch(...) {
                	ft = false;
                }
            }
            else
            	ft = false;
        }
    }
    else if (Ext == ".ICO") {
    	ft = true;
        handle = ::LoadImage(HInstance, PathName.c_str(), IMAGE_ICON, 0, 0,
         LR_DEFAULTCOLOR | LR_LOADFROMFILE);

        if (handle == NULL) {
        	ft = false;
        }
        else {
        	::FindFirstFile(PathName.c_str(), &ffd);

            size = ffd.nFileSizeLow;
            if (size > 766)
            	size = 48;
            else if (size > 318)
            	size = 32;
            else
            	size = 16;

            width = (int)size;
            height = (int)size;

        	Image1->Width = width;
            Image1->Height = height;

            Image1->Picture->Bitmap->Width = width;
            Image1->Picture->Bitmap->Height = height;

            Image1->Canvas->Pen->Color = Color;		// ViewForm ̃J[
            Image1->Canvas->Brush->Color = Color;	// ViewForm ̃J[
            Image1->Canvas->Brush->Style = bsSolid;
            Image1->Canvas->FillRect(Rect(0, 0, width, height));

            ::DrawIconEx(Image1->Canvas->Handle, 0, 0, handle, width, height,
             0, NULL, DI_NORMAL);

            ::CloseHandle(handle);
        }
    }
    else if (Ext == ".CUR") {
    	ft = true;
        handle = ::LoadImage(HInstance, PathName.c_str(), IMAGE_CURSOR, 0, 0,
         LR_DEFAULTCOLOR | LR_LOADFROMFILE);

        if (handle == NULL) {
        	ft = false;
        }
        else {
            width = 32;
            height = 32;

        	Image1->Width = width;
            Image1->Height = height;

            Image1->Picture->Bitmap->Width = width;
            Image1->Picture->Bitmap->Height = height;

            Image1->Canvas->Pen->Color = Color;		// ViewForm ̃J[
            Image1->Canvas->Brush->Color = Color;	// ViewForm ̃J[
            Image1->Canvas->Brush->Style = bsSolid;
            Image1->Canvas->FillRect(Rect(0, 0, width, height));

            ::DrawIconEx(Image1->Canvas->Handle, 0, 0, handle, width, height,
             0, NULL, DI_NORMAL);

            ::CloseHandle(handle);
        }
    }
    else if (Ext == ".WMF" || Ext == ".EMF") {
        ft = true;

        if (Ext == ".EMF") {
        	hEnhMetaFile = ::GetEnhMetaFile(PathName.c_str());
        }
        else {
        	ShortName = LongToShort(PathName);
        	hMetaFile = ::GetMetaFile(ShortName.c_str());
            bufsize = ::GetMetaFileBitsEx(hMetaFile, 0, NULL);
            buf = (LPBYTE)::GlobalAlloc(GPTR, bufsize);
            ::GetMetaFileBitsEx(hMetaFile, bufsize, buf);
            hEnhMetaFile = ::SetWinMetaFileBits(bufsize, buf,
             Image1->Canvas->Handle, NULL);
            ::GlobalFree(buf);
        }

        if (hEnhMetaFile == NULL) {
        	ft = false;
        }
        else {
            ::ZeroMemory(&EnhMetaHeader, sizeof(ENHMETAHEADER));

            ::GetEnhMetaFileHeader(hEnhMetaFile, sizeof(ENHMETAHEADER), &EnhMetaHeader);

            width = EnhMetaHeader.rclFrame.right - EnhMetaHeader.rclFrame.left + 1;
            height = EnhMetaHeader.rclFrame.bottom - EnhMetaHeader.rclFrame.top + 1;

            width = Screen->Width * width  / EnhMetaHeader.szlMillimeters.cx / 100;
            height = Screen->Height * height / EnhMetaHeader.szlMillimeters.cy / 100;

        	Image1->Width = width;
            Image1->Height = height;

            Image1->Picture->Bitmap->Width = width;
            Image1->Picture->Bitmap->Height = height;

            Image1->Canvas->Pen->Color = Color;		// ViewForm ̃J[
            Image1->Canvas->Brush->Color = Color;	// ViewForm ̃J[
            Image1->Canvas->Brush->Style = bsSolid;
            Image1->Canvas->FillRect(Rect(0, 0, width, height));

            rect.left = 0L;
            rect.right = (LONG)(width - 1);
            rect.top = 0L;
            rect.bottom = (LONG)(height - 1);

        	::PlayEnhMetaFile(Image1->Canvas->Handle, hEnhMetaFile, &rect);

            ::DeleteEnhMetaFile(hEnhMetaFile);
        }
    }
    else if (Ext == ".EXE" || Ext == ".DLL") {
        icon = new TIcon;

        ft = true;
        ilist = ::SHGetFileInfo(PathName.c_str(), FILE_ATTRIBUTE_ARCHIVE, &shfi,
         sizeof(SHFILEINFO), SHGFI_ICON | SHGFI_LARGEICON);

        if (ilist == 0) {
        	ft = false;
        }
        else {
    		icon->ReleaseHandle();
    		icon->Handle = shfi.hIcon;

            width = icon->Width;
            height = icon->Height;

        	Image1->Width = width;
            Image1->Height = height;

            Image1->Picture->Bitmap->Width = width;
            Image1->Picture->Bitmap->Height = height;

            Image1->Canvas->Pen->Color = Color;		// ViewForm ̃J[
            Image1->Canvas->Brush->Color = Color;	// ViewForm ̃J[
            Image1->Canvas->Brush->Style = bsSolid;
            Image1->Canvas->FillRect(Rect(0, 0, width, height));

            Image1->Canvas->Draw(0, 0, icon);
        }

        delete icon;
    }

    if (ft == false) {
        bitmap = new Graphics::TBitmap;

		ft = FrameForm->SusieView(PathName, bitmap);

        if (ft) {
        	Image1->Picture->Bitmap->Width = bitmap->Width;
        	Image1->Picture->Bitmap->Height = bitmap->Height;

            Image1->Picture->Bitmap->Canvas->StretchDraw(Rect(0, 0,
             bitmap->Width, bitmap->Height), bitmap);

            Image1->Width = bitmap->Width;
            Image1->Height = bitmap->Height;
        }

        delete bitmap;
    }

    if (ft == false) {
    	FrameForm->Stretch = stretch;
    	ShowMessage("Can't open " + Caption);
        Tag = 2;
        Close();
        return;
    }
    else {
    	count = FrameForm->MDIChildCount;
    	if (FrameForm->ListSetting)
    	count--;

		if (count == 1) {
        	FrameForm->ActiveSpeedBar();
        }
    }

    if (Image1->Width < 104) {
    	ClientWidth = 104;
        ClientHeight = ClientWidth * Image1->Height / Image1->Width;
    }
    else {
    	ClientHeight = Image1->Height;
        ClientWidth = Image1->Width;
    }

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
     + " * " + IntToStr(Image1->Height);
    FrameForm->StatusBar1->Panels->Items[1]->Text = "";
	FrameForm->StatusBar1->Panels->Items[4]->Text = PathName;
    RealWidth = Image1->Width;
    RealHeight = Image1->Height;
    OrgWidth = RealWidth;
    OrgHeight = RealHeight;

    Tag = 0;
    AutoScroll = true;

    FrameForm->Stretch = stretch;

    StoreUndoBitmap(true);		// ύXÕC[WۑĂ
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Image1MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
    int x, y;

	if (!Active || FrameForm->TimerOn)
    	return;

    if (Tag == 1) {
    	Tag = 0;
        if (Button == mbLeft)
        	return;
    }

    if (FrameForm->DrawSetting) {
        x = X * OrgWidth / Image1->Width;
    	y = Y * OrgHeight / Image1->Height;

        if (Button == mbLeft) {
    		FrameForm->Drawing = true;		// `JnƂTC
        	StoreUndoBitmap(true);			// `ÕC[WۑĂ

            if (FrameForm->DrawTool == 63) {
                FrameForm->Panel3->Color = Image1->Canvas->Pixels[x][y];
        		FrameForm->DrawColor = FrameForm->Panel3->Color;
            }
            SetDrawColor();

        	Image1->Canvas->MoveTo(x, y);
        	FrameForm->OriginPt = Point(x, y);
        	FrameForm->MovePt = FrameForm->OriginPt;

        	if ((FrameForm->DrawTool > 53 && FrameForm->DrawTool < 57)
             || FrameForm->DrawTool == 63) {
        		DrawObje(FrameForm->OriginPt, false); // _AuVAXv[AS̏ꍇ
            }

            if (FrameForm->DrawTool == 55 || FrameForm->DrawTool == 63)
            	Image1->Canvas->Pen->Width = FrameForm->DrawWidth; // uVAS̏ꍇ
        }
        else if (Button == mbRight) {
    		FrameForm->Panel3->Color = Image1->Canvas->Pixels[x][y];
        	FrameForm->DrawColor = FrameForm->Panel3->Color;
    		SetDrawColor();
    	}

        FrameForm->StatusBar1->Panels->Items[1]->Text = "\(" + IntToStr(X) + "\, "
		 + IntToStr(Y) + "\)";

        return;
    }

    if (FrameForm->AreaSetting) {
        if (Button == mbLeft) {
            if (X > Image1->Width - 4 || Y > Image1->Height - 4)
                return;

            ClearArea();
            Alx = X;
            Aly = Y;
            DrawArea();
            if (FrameForm->TextSetting) {
            	TextForm->DrawText();
                TextForm->DrawRing();
            }
        }
        else if (Button == mbRight) {
            if (X < Alx + 4 || Y < Aly + 4)
                return;

            ClearArea();
            Arx = X;
            Ary = Y;
            FrameForm->Awidth = Arx - Alx + 1;
            FrameForm->Aheight = Ary - Aly + 1;
            DrawArea();
            if (FrameForm->TextSetting) {
            	TextForm->DrawText();
                TextForm->DrawRing();
            }
        }

        return;
    }

    FrameForm->StatusBar1->Panels->Items[1]->Text = "";

    bool stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;
    AutoScroll = false;

	Image1->AutoSize = false;
    Image1->Stretch = true;

    if (Button == mbLeft) {
    	if (Image1->Height >= 18 && Image1->Width >= 18) {
        	Image1->Height /= 1.1;
            Image1->Width /= 1.1;
        }
    }
    else if (Button == mbRight) {
        if (Image1->Height < Screen->Height * 4 && Image1->Width < Screen->Width * 4) {
        	Image1->Height *= 1.1;
            Image1->Width *= 1.1;
        }
    }

    if (Shift.Contains(ssShift)) {
	    if (Image1->Width < 104) {
    		ClientWidth = 104;
        	ClientHeight = ClientWidth * Image1->Height / Image1->Width;
	    }
		else {
    		ClientHeight = Image1->Height;
    		ClientWidth = Image1->Width;
		}
    }

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
     + " * " + IntToStr(Image1->Height);

    AutoScroll = true;
    FrameForm->Stretch = stretch;

    StoreUndoData(false);
    StoreUndoBitmap(false);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormResize(TObject *Sender)
{
    Image1->AutoSize = false;
	Image1->Stretch = true;

    if (FrameForm->Stretch) {
        Image1->Height = ClientHeight;
        Image1->Width = ClientWidth;

	    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
    	 + " * " + IntToStr(Image1->Height);
        FrameForm->StatusBar1->Panels->Items[1]->Text = "";

        StoreUndoData(false);
        StoreUndoBitmap(false);
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormCreate(TObject *Sender)
{
    Width = 112;
    Height = 41;

    NewImageColor = clWhite;

	Image1->AutoSize = true;
    Image1->Stretch = false;

    Stretch1->Checked = FrameForm->Stretch;
    Areasetting1->Checked = FrameForm->AreaSetting;
    Text1->Checked = FrameForm->TextSetting;
    View1->Checked = FrameForm->ListSetting;

    Alx = 0;
    Aly = 0;
    Arx = 100;
    Ary = 100;

    UndoHandle = FrameForm->UndoHandleCount;
    FrameForm->UndoHandleCount++;

    Draw = false;
    ListChild = false;
    Modefied = false;

    RealWidth = Image1->Width;
    RealHeight = Image1->Height;
    OrgWidth = RealWidth;
    OrgHeight = RealHeight;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Setup1Click(TObject *Sender)
{
    int	ratio;

	PrintRatioForm = new TPrintRatioForm (this);

    PrintRatioForm->ShowModal();

    if (PrintRatioForm->ModalResult != mrOk) {
    	delete PrintRatioForm;
        return;
    }

    try {
    	ratio = StrToInt(PrintRatioForm->Edit1->Text.Trim());
    }
    catch(...) {
    	delete PrintRatioForm;
        ShowMessage("͒l܂B");
        return;
    }

    delete PrintRatioForm;

    if (ratio < 2)
    	ratio = 2;
    else if (ratio > 200)
    	ratio = 200;

    FrameForm->RPrintRatio = ratio;

	PrinterSetupDialog1->Execute();

    FrameForm->SetPrinterParam();
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Print2Click(TObject *Sender)
{
    int	lx, ly;
    int rx, ry;
    int i, handle;
    AnsiString	TempFile;

    if (FrameForm->Tag == 1) {
    	FrameForm->SetPrinterParam();
        FrameForm->Tag = 0;
    }

    /*
	if (PrintDialog1->Execute()) {
    	Printer()->BeginDoc();

        px = GetDeviceCaps(Printer()->Canvas->Handle, LOGPIXELSX);
        px = Image1->Width * px / 80;
        py = GetDeviceCaps(Printer()->Canvas->Handle, LOGPIXELSY);
        py = Image1->Height * py / 80;

        Printer()->Canvas->StretchDraw(Rect(0, 0, px, py), Image1->Picture->Bitmap);

        Printer()->EndDoc();
    }
    */

    if (PrintDialog1->Execute()) {
        for (i = 0; i < 100; i++) {
			TempFile = FrameForm->SystemRoot + "\\Tempiv" + IntToStr(i) + ".bmp";
            handle = open(TempFile.c_str(), O_RDONLY | O_BINARY);
            if (handle == -1)
            	break;
            else
            	close(handle);
        }
        if (i == 100)
        	return;

    	Graphics::TBitmap *bitmap = new Graphics::TBitmap;

    	bitmap->Height = Image1->Height;
    	bitmap->Width = Image1->Width;
    	bitmap->Canvas->StretchDraw(Rect(0, 0, Image1->Width, Image1->Height),
    	Image1->Picture->Bitmap);
    	bitmap->SaveToFile(TempFile);
    	bitmap->LoadFromFile(TempFile);
    	unlink(TempFile.c_str());

        if (FrameForm->psw) {
        	lx = FrameForm->Ly;
            ly = FrameForm->rx - 1 - FrameForm->Lx;
        }
        else {
        	lx = FrameForm->Lx;
            ly = FrameForm->Ly;
        }

        lx = lx * FrameForm->rr * FrameForm->px / 80;
        ly = ly * FrameForm->rr * FrameForm->py / 80;

        rx = bitmap->Width * FrameForm->px * FrameForm->RPrintRatio / 100 / 80;
        ry = bitmap->Height * FrameForm->py * FrameForm->RPrintRatio / 100 / 80;

        Printer()->BeginDoc();

        Printer()->Canvas->StretchDraw(Rect(lx, ly, lx + rx - 1, ly + ry - 1), bitmap);

        Printer()->EndDoc();

        delete bitmap;
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Save1Click(TObject *Sender)
{
    int pos;
    int index;
    int jpegratio;
    bool areasetting;
    bool textsetting;
    AnsiString SaveName;
    LPSTR Lpstr;
    HANDLE ImageHandle;
    int InfoSize;
    int ImageSize;

    areasetting = FrameForm->AreaSetting;
    textsetting = FrameForm->TextSetting;

    if (textsetting)
    	Text1Click(Sender);
    else if (areasetting)
    	Areasetting1Click(Sender);

	SaveFileForm = new TSaveFileForm (this);

    SaveFileForm->ShowModal();

    if (SaveFileForm->ModalResult != mrOk) {
    	delete SaveFileForm;

        if (textsetting)
    		Text1Click(Sender);
    	else if (areasetting)
    		Areasetting1Click(Sender);

        return;
    }

    if (FrameForm->RSaveDir != "")
    	SaveFileDialog->InitialDir = FrameForm->RSaveDir;

    if (Caption == "Untitled") {
    	SaveName = "ListView";
    }
    else {
    	SaveName = ExtractFileName(PathName);
    	pos = SaveName.Pos(".");
    	if (pos != 0)
        	SaveName.SetLength(pos - 1);
    }

	SaveFileDialog->FileName = SaveName;

    SaveFileDialog->FilterIndex = SaveFileForm->RadioGroup1->ItemIndex + 1;
    index = SaveFileDialog->FilterIndex;

    delete SaveFileForm;

    FrameForm->RSaveFileType = index;
    jpegratio = FrameForm->RJpegRatio;

    if (jpegratio < 1)
    	jpegratio = 1;
    else if(jpegratio > 99)
    	jpegratio = 99;

    if (index == 1)
    	SaveFileDialog->DefaultExt = "bmp";
    else if (index == 2)
    	SaveFileDialog->DefaultExt = "jpg";
    else if (index == 3)
    	SaveFileDialog->DefaultExt = "tif";
    else if (index == 4)
    	SaveFileDialog->DefaultExt = "ico";

    if (SaveFileDialog->Execute()) {
        index = SaveFileDialog->FilterIndex;

    	Graphics::TBitmap *bitmap = new Graphics::TBitmap;

    	bitmap->Height = Image1->Height;
    	bitmap->Width = Image1->Width;
		bitmap->Canvas->StretchDraw(Rect(0, 0, Image1->Width, Image1->Height),
         Image1->Picture->Bitmap);

		if (index == 1) {
    		 bitmap->SaveToFile(SaveFileDialog->FileName);
        }
        else if (index == 2 || index == 3) {
            GetDIBSizes(bitmap->Handle, InfoSize, ImageSize);
            ImageHandle = GlobalAlloc(GHND, InfoSize + ImageSize);
            if (ImageHandle == NULL) {
            	delete bitmap;

                if (textsetting)
    				Text1Click(Sender);
                else if (areasetting)
    				Areasetting1Click(Sender);

            	return;
            }
            Lpstr = (LPSTR)GlobalLock(ImageHandle);
            GetDIB(bitmap->Handle, bitmap->Palette, (void *)Lpstr, (void *)(Lpstr + InfoSize));
            GlobalUnlock(ImageHandle);

            SaveName = "Saving to " + ExtractFileName(SaveFileDialog->FileName);

            if (index == 2)
            	ImgKitJpegFileSave(SaveFileDialog->FileName.c_str(), ImageHandle,
                SaveName.c_str(), "JPEG", jpegratio, 0);
            else if (index == 3)
            	ImgKitTiffFileSave(SaveFileDialog->FileName.c_str(), ImageHandle,
                SaveName.c_str(), "TIFF", 5);

            GlobalFree(ImageHandle);
        }
        else if (index == 4) {
        	SaveToIcon(SaveFileDialog->FileName);
        }

        delete bitmap;

        SaveName = SaveFileDialog->FileName;
        pos = SaveName.Pos(ExtractFileName(SaveName));
        if (pos > 4)
        	pos--;
        SaveName.SetLength(pos - 1);

        FrameForm->RSaveDir = SaveName;
        FrameForm->RSaveFileType = index;
    	FrameForm->RJpegRatio = jpegratio;

        Modefied = false;
        RealWidth = Image1->Width;
    	RealHeight = Image1->Height;
    	OrgWidth = RealWidth;
    	OrgHeight = RealHeight;
    }
    else {
    	if (textsetting)
    		Text1Click(Sender);
    	else if (areasetting)
    		Areasetting1Click(Sender);
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormActivate(TObject *Sender)
{
    ViewForm = this;

    if (FrameForm->TimerOn || Caption == "Untitled")
    	return;

    Tag = 1;

    Stretch1->Checked = FrameForm->Stretch;
    Areasetting1->Checked = FrameForm->AreaSetting;
    Text1->Checked = FrameForm->TextSetting;
    View1->Checked = FrameForm->ListSetting;

    StoreUndoBitmap(true);		// ύXÕC[WۑĂ

    if (FrameForm->AreaSetting) {
        DrawArea();
        if (FrameForm->TextSetting) {
        	TextForm->DrawText();
            TextForm->DrawRing();
        }
        Areacolor1->Enabled = true;
    }
    else {
        Areacolor1->Enabled = false;
	}

    if (FrameForm->DrawSetting) {
    	SetDrawColor();
    }

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
     + " * " + IntToStr(Image1->Height);
    FrameForm->StatusBar1->Panels->Items[1]->Text = "";
    FrameForm->StatusBar1->Panels->Items[4]->Text = PathName;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Image1MouseMove(TObject *Sender, TShiftState Shift,
	int X, int Y)
{
    int x, y;

	if (!Active || FrameForm->TimerOn)
    	return;

	if (FrameForm->DrawSetting) {
    	x = X * OrgWidth / Image1->Width;
    	y = Y * OrgHeight / Image1->Height;

        if (FrameForm->Drawing) {
        	if (FrameForm->DrawTool < 54) {	// AlpApۂ̎lpA~Aȉ~̏ꍇ
        		DrawShape(FrameForm->OriginPt, FrameForm->MovePt, pmNotXor);
            	FrameForm->MovePt = Point(x, y);
            	DrawShape(FrameForm->OriginPt, FrameForm->MovePt, pmNotXor);
        	}
        	else {						// _AuVASAXv[AʂԂ̏ꍇ
            	FrameForm->MovePt = Point(x, y);
            	if (FrameForm->DrawTool != 57)	// ʂԂȊȌꍇ
            		DrawObje(FrameForm->MovePt, true);
        	}
        }
        else {
        	FrameForm->Panel7->Color = Image1->Canvas->Pixels[x][y];
    		FrameForm->Panel7->Update();
            FrameForm->DispRGB(true);
        }
    }

    FrameForm->StatusBar1->Panels->Items[1]->Text = "\(" + IntToStr(X) + "\, "
	 + IntToStr(Y) + "\)";
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Original1Click(TObject *Sender)
{
    bool stretch;

    if (FrameForm->ListSetting) {
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    if (WindowState == wsMaximized)
    	WindowState = wsNormal;

    if (FrameForm->TextSetting)
    	Text1Click(Sender);
    else if (FrameForm->AreaSetting)
    	Areasetting1Click(Sender);

	stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;
    AutoScroll = false;

    Image1->AutoSize = false;
    Image1->Stretch = true;

	Image1->Height = Image1->Picture->Bitmap->Height;
	Image1->Width = Image1->Picture->Bitmap->Width;

    if (Image1->Width < 104) {
    	ClientWidth = 104;
        ClientHeight = ClientWidth * Image1->Height / Image1->Width;
    }
    else {
    	ClientHeight = Image1->Height;
    	ClientWidth = Image1->Width;
    }

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
     + " * " + IntToStr(Image1->Height);
    FrameForm->StatusBar1->Panels->Items[1]->Text = "";

    AutoScroll = true;
	FrameForm->Stretch = stretch;

    StoreUndoData(false);
    StoreUndoBitmap(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Stretch1Click(TObject *Sender)
{
    if (FrameForm->ListSetting) {
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    if (WindowState == wsMaximized)
    	WindowState = wsNormal;

	if (FrameForm->Stretch) {
    	FrameForm->Stretch = false;
    	Stretch1->Checked = false;
        FrameForm->SpeedButton25->Down = false;
    }
    else {
    	if (FrameForm->TextSetting)
    		Text1Click(Sender);
    	else if (FrameForm->AreaSetting)
    		Areasetting1Click(Sender);

        FrameForm->Stretch = true;
    	Stretch1->Checked = true;
        FrameForm->SpeedButton25->Down = true;
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Preview1Click(TObject *Sender)
{
	int	Result;

    if (FrameForm->Tag == 1) {
    	FrameForm->SetPrinterParam();
        FrameForm->Tag = 0;
    }

    ViewForm = this;

	PreviewForm = new TPreviewForm (this);

    Result = PreviewForm->ShowModal();

    delete PreviewForm;

    if (Result == mrYes)
    	Print2Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Wallpaper1Click(TObject *Sender)
{
    int	Result;
    int pos;
    bool areasetting;
    bool textsetting;
    AnsiString Wallpaper;

    if (FrameForm->TileWallpaper == "")
    	return;

    areasetting = FrameForm->AreaSetting;
    textsetting = FrameForm->TextSetting;

    if (textsetting)
    	Text1Click(Sender);
    else if (areasetting)
    	Areasetting1Click(Sender);

    ViewForm = this;

	WallForm = new TWallForm (this);

    if (FrameForm->TileWallpaper == "0")
    	WallForm->RadioGroup1->ItemIndex = 0;
    else if (FrameForm->TileWallpaper == "1")
    	WallForm->RadioGroup1->ItemIndex = 1;

    Result = WallForm->ShowModal();

    if (Result == mrOk) {
    	if (FrameForm->SystemRoot != "") {
        	Wallpaper = FrameForm->SystemRoot + "\\" + ExtractFileName(PathName);
			pos = Wallpaper.Pos(".");
            if (pos != 0)
        		Wallpaper.SetLength(pos - 1);
            Wallpaper += ".bmp";

    	    if (WallForm->RadioGroup1->ItemIndex == 0)
        		FrameForm->TileWallpaper = "0";
        	else if (WallForm->RadioGroup1->ItemIndex == 1)
        		FrameForm->TileWallpaper = "1";

        	Graphics::TBitmap *bitmap = new Graphics::TBitmap;

    		bitmap->Height = Image1->Height;
    		bitmap->Width = Image1->Width;
			bitmap->Canvas->StretchDraw(Rect(0, 0, Image1->Width, Image1->Height),
             Image1->Picture->Bitmap);
    		bitmap->SaveToFile(Wallpaper);

        	delete bitmap;

            TRegistry *reg = new TRegistry;
    		reg->RootKey = HKEY_CURRENT_USER;

        	if (reg->OpenKey("\\Control Panel\\desktop", false)) {
            	reg->WriteString("Wallpaper", Wallpaper);
           	 	reg->WriteString("TileWallpaper", FrameForm->TileWallpaper);
        	}

            delete reg;

            SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, Wallpaper.c_str(), 0);
    	}
    }

    delete WallForm;

    if (textsetting)
    	Text1Click(Sender);
    else if (areasetting)
    	Areasetting1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::TurnBitmap(Graphics::TBitmap *bitmap, int angle)
{
    int	i, j, x, y;
    int width, height;
    int	count, interval;
    int ratio;
    TColor pixel;
    Graphics::TBitmap *bitmap2;

    if (FrameForm->ListSetting) {
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    if (WindowState == wsMaximized)
    	WindowState = wsNormal;

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Turning " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    if (FrameForm->preview == false)
    	TimerForm->Button1->Enabled = true;
    else
        TimerForm->Button1->Enabled = false;

    if (angle == 90) {
    	bitmap2->Width = height;
        bitmap2->Height = width;

        for (y = 0, i = height - 1; y < height && i >= 0; y++, i--) {
        	for (x = 0, j = 0; x < width && j < width; x++, j++) {
                if (FrameForm->TimerCancel)
        			break;

            	pixel = bitmap->Canvas->Pixels[x][y];
                bitmap2->Canvas->Pixels[i][j] = pixel;
            }
            if (FrameForm->TimerCancel)
        		break;

            count++;
        	if ((count % interval) == 0)
        		TimerForm->ProgressBar1->StepIt();

            ratio = count * 100 / height;
            TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        	Application->ProcessMessages();
        }
        if (FrameForm->TimerCancel) {
            TimerForm->Close();
		    delete bitmap2;
            return;
        }

        bitmap->Width = height;
        bitmap->Height = width;
        bitmap->Canvas->StretchDraw(Rect(0, 0, height, width), bitmap2);
    }
    else if (angle == 180) {
    	bitmap2->Width = width;
        bitmap2->Height = height;

    	for (y = 0, j = height - 1; y < height && j >= 0; y++, j--) {
        	for (x = 0, i = width - 1; x < width && i >= 0; x++, i--) {
                if (FrameForm->TimerCancel)
        			break;

            	pixel = bitmap->Canvas->Pixels[x][y];
                bitmap2->Canvas->Pixels[i][j] = pixel;
            }
            if (FrameForm->TimerCancel)
            	break;

            count++;
        	if ((count % interval) == 0)
        		TimerForm->ProgressBar1->StepIt();

            ratio = count * 100 / height;
            TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        	Application->ProcessMessages();
        }
        if (FrameForm->TimerCancel) {
            TimerForm->Close();
		    delete bitmap2;
            return;
        }

        bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);
    }
    else if (angle == 270) {
    	bitmap2->Width = height;
        bitmap2->Height = width;

        for (y = 0, i = 0; y < height && i < height; y++, i++) {
        	for (x = 0, j = width - 1; x < width && j >= 0; x++, j--) {
                if (FrameForm->TimerCancel)
        			break;

            	pixel = bitmap->Canvas->Pixels[x][y];
                bitmap2->Canvas->Pixels[i][j] = pixel;
            }
            if (FrameForm->TimerCancel)
            	break;

            count++;
        	if ((count % interval) == 0)
        		TimerForm->ProgressBar1->StepIt();

            ratio = count * 100 / height;
            TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        	Application->ProcessMessages();
        }
        if (FrameForm->TimerCancel) {
            TimerForm->Close();
		    delete bitmap2;
            return;
        }

        bitmap->Width = height;
        bitmap->Height = width;
        bitmap->Canvas->StretchDraw(Rect(0, 0, height, width), bitmap2);
    }
    else if (angle == -1) {
    	bitmap2->Width = width;
        bitmap2->Height = height;

    	for (y = 0, j = 0; y < height && j < height; y++, j++) {
        	for (x = 0, i = width - 1; x < width && i >= 0; x++, i--) {
                if (FrameForm->TimerCancel)
        			break;

            	pixel = bitmap->Canvas->Pixels[x][y];
                bitmap2->Canvas->Pixels[i][j] = pixel;
            }
            if (FrameForm->TimerCancel)
            	break;

            count++;
        	if ((count % interval) == 0)
        		TimerForm->ProgressBar1->StepIt();

            ratio = count * 100 / height;
            TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        	Application->ProcessMessages();
        }
        if (FrameForm->TimerCancel) {
            TimerForm->Close();
		    delete bitmap2;
            return;
        }

        bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);
    }

    TimerForm->Close();

    delete bitmap2;

	if (FrameForm->preview == false) {
    	Modefied = true;
        StoreUndoData(true);
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::N901Click(TObject *Sender)
{
    int temp;

    if (FrameForm->AreaSetting)
        ClearArea();

	TurnBitmap(Image1->Picture->Bitmap, 90);
    if (FrameForm->TimerCancel)
    	return;
    ReForm();

    temp = OrgWidth;
    OrgWidth = OrgHeight;
    OrgHeight = temp;

//    if (FrameForm->AreaSetting)
//        ViewForm->FormActivate(Sender);
}
//--------------------------------------------------------------------------
void __fastcall TViewForm::ReForm(void)
{
    int	width, height;
    bool stretch;

    stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;
    AutoScroll = false;

    width = Image1->Width;
    height = Image1->Height;

    Image1->Width = height;
    Image1->Height = width;

    if (Image1->Width < 104) {
    	ClientWidth = 104;
        ClientHeight = ClientWidth * Image1->Height / Image1->Width;
    }
    else {
    	ClientHeight = Image1->Height;
    	ClientWidth = Image1->Width;
    }

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
     + " * " + IntToStr(Image1->Height);
    FrameForm->StatusBar1->Panels->Items[1]->Text = "";

    AutoScroll = true;
	FrameForm->Stretch = stretch;
}
//--------------------------------------------------------------------------
void __fastcall TViewForm::N1801Click(TObject *Sender)
{
    if (FrameForm->AreaSetting)
        ClearArea();

	TurnBitmap(Image1->Picture->Bitmap, 180);
    if (FrameForm->TimerCancel)
    	return;

//    if (FrameForm->AreaSetting)
//        ViewForm->FormActivate(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::N2701Click(TObject *Sender)
{
	int temp;

    if (FrameForm->AreaSetting)
        ClearArea();

	TurnBitmap(Image1->Picture->Bitmap, 270);
    if (FrameForm->TimerCancel)
    	return;
    ReForm();

    temp = OrgWidth;
    OrgWidth = OrgHeight;
    OrgHeight = temp;

//    if (FrameForm->AreaSetting)
//        ViewForm->FormActivate(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Revers1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting)
        ClearArea();

	TurnBitmap(Image1->Picture->Bitmap, -1);
    if (FrameForm->TimerCancel)
    	return;

//    if (FrameForm->AreaSetting)
//        ViewForm->FormActivate(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Originalimage1Click(TObject *Sender)
{
    bool stretch;

    if (FrameForm->ListSetting) {
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    if (WindowState == wsMaximized)
    	WindowState = wsNormal;

    if (FrameForm->TextSetting)
    	Text1Click(Sender);
    else if (FrameForm->AreaSetting)
    	Areasetting1Click(Sender);

    stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;
    AutoScroll = false;

    Image1->AutoSize = false;
    Image1->Stretch = true;

    if (PathName == Caption) {
    	Image1->Height--;
        Image1->Picture->Bitmap->Height--;

    	Image1->Picture->Bitmap->Width = RealWidth;
    	Image1->Picture->Bitmap->Height = RealHeight;

    	Image1->Width = RealWidth;
    	Image1->Height = RealHeight;

    	if (Image1->Width < 104) {
    		ClientWidth = 104;
        	ClientHeight = ClientWidth * Image1->Height / Image1->Width;
    	}
    	else {
    		ClientHeight = Image1->Height;
    		ClientWidth = Image1->Width;
    	}

        FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(RealWidth)
     	 + " * " + IntToStr(RealHeight);
    	FrameForm->StatusBar1->Panels->Items[1]->Text = "";

    	Image1->Canvas->Pen->Color = clWhite;
        Image1->Canvas->Pen->Style = psSolid;
        Image1->Canvas->Brush->Color = NewImageColor;
        Image1->Canvas->Brush->Style = bsSolid;
        Image1->Canvas->Rectangle(0, 0, Image1->Width + 1, Image1->Height + 1);
    }
    else {
        Image1->Height--;
        Image1->Picture->Bitmap->Height--;
		Open(PathName);
    }

    Image1->Refresh();

    AutoScroll = true;
    FrameForm->Stretch = stretch;

    Modefied = false;

    FrameForm->InitUndoData();
    StoreUndoBitmap(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormKeyDown(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
    int width, height;

	if (!Active || FrameForm->TimerOn)
    	return;

    if (Key == VK_NUMPAD0 || Key == VK_HOME) {
        if (FrameForm->AreaSetting) {
        	ClearArea();
            FrameForm->Awidth = 100;
            FrameForm->Aheight = 100;
            if (Shift.Contains(ssCtrl)) {
            	Alx = 0;
                Aly = 0;
                Arx = 100;
                Ary = 100;
            }
            DrawArea();
            if (FrameForm->TextSetting) {
            	TextForm->DrawText();
                TextForm->DrawRing();
            }
        }
        else {
    		if (Shift.Contains(ssCtrl))
            	Originalimage1Click(Sender);
        	else
    			Original1Click(Sender);
        }
    }
    else if (Key == VK_ADD || Key == VK_PRIOR || Key == VK_SUBTRACT || Key == VK_NEXT) {
        if (FrameForm->AreaSetting) {
            if (Key == VK_ADD || Key == VK_PRIOR) {
                width = FrameForm->Awidth * 11 / 10;
                height = FrameForm->Aheight * 11 / 10;
                if (width > Image1->Width || height > Image1->Height)
                    return;
            }
            else if (Key == VK_SUBTRACT || Key == VK_NEXT) {
                width = FrameForm->Awidth * 10 / 11;
                height = FrameForm->Aheight * 10 / 11;
                if (width < 24 || height < 24)
                    return;
            }
            ClearArea();
            FrameForm->Awidth = width;
            FrameForm->Aheight = height;
            DrawArea();
            if (FrameForm->TextSetting) {
            	TextForm->DrawText();
                TextForm->DrawRing();
            }
            return;
        }

        FrameForm->StatusBar1->Panels->Items[1]->Text = "";
	    bool stretch = FrameForm->Stretch;
    	FrameForm->Stretch = false;
    	AutoScroll = false;

		Image1->AutoSize = false;
    	Image1->Stretch = true;

        if (Key == VK_ADD || Key == VK_PRIOR) {
	        if (Image1->Height < Screen->Height * 4 && Image1->Width < Screen->Width * 4) {
        		Image1->Height *= 1.1;
            	Image1->Width *= 1.1;
    		}
        }
        else if (Key == VK_SUBTRACT || Key == VK_NEXT) {
        	if (Image1->Height >= 18 && Image1->Width >= 18) {
        		Image1->Height /= 1.1;
        		Image1->Width /= 1.1;
            }
        }

	    if (Image1->Width < 104) {
    		ClientWidth = 104;
        	ClientHeight = ClientWidth * Image1->Height / Image1->Width;
	    }
		else {
    		ClientHeight = Image1->Height;
    		ClientWidth = Image1->Width;
		}

        FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
		 + " * " + IntToStr(Image1->Height);

    	AutoScroll = true;
    	FrameForm->Stretch = stretch;

        StoreUndoData(false);
        StoreUndoBitmap(false);
    }
    else if (Key == VK_RETURN) {
    	if (FrameForm->TextSetting) {
        	TextForm->SetFocus();
            TextForm->Edit1->SetFocus();
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::EffectBitmap(Graphics::TBitmap *bitmap, int effect)
{
    int	x, y;
    int width, height;
    int	count, interval;
    int ratio;
    int pixel, value, color;
    Graphics::TBitmap *bitmap2;

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;

    if (effect == 1)
    	color = 0x000000ff;							// Red
    else if (effect == 2)
    	color = 0x00ff0000;							// Blue
    else if (effect == 3)
    	color = 0x00ff00ff;							// Purple
	else
    	color = 0;

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
            if (FrameForm->TimerCancel)
        			break;

        	pixel = bitmap->Canvas->Pixels[x][y];
            value = pixel & 0x000000ff;				// Red
            value += (pixel & 0x0000ff00) >> 8;		// Green
            value += (pixel & 0x00ff0000) >> 16;	// Blue
            value /= 3;
            pixel = value | (value << 8) | (value << 16);
            value = pixel & color;
            value = ~value;
            value &= color;
            pixel |= value;

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Rename1Click(TObject *Sender)
{
    int i, j, Result;

    if (FrameForm->ListSetting && ListChild)
    	j = ListForm->ListFiles->IndexOf(Caption);
    else
    	j = -1;

    ViewForm = this;

	DeReForm = new TDeReForm (this);

    DeReForm->Tag = 0;
    if (PathName == Caption) {
        DeReForm->Caption = "C[W̕ύX";
    	DeReForm->Label1->Caption = "Full Name  : ";
        DeReForm->Label4->Caption = "C[WύX܂H";
    }
    else
    	DeReForm->Caption = "t@C̕ύX";

	DeReForm->Label5->Caption = PathName;
    DeReForm->Label2->Caption = "Old Name  : " + Caption;
    DeReForm->Edit1->Text = Caption;

    DeReForm->ClientWidth = DeReForm->Label5->Width + 90;
    if (DeReForm->ClientWidth < 320)
    	DeReForm->ClientWidth = 320;
    else if (DeReForm->ClientWidth > 600)
    	DeReForm->ClientWidth = 600;

    Result = DeReForm->ShowModal();
    delete DeReForm;

    if (Result == mrYes) {
        i = PathName.Length() - ExtractFileName(PathName).Length() + 1;
        PathName.Delete(i, ExtractFileName(PathName).Length());
        PathName.Insert(Caption, i);
        FrameForm->StatusBar1->Panels->Items[4]->Text = PathName;

        if (j != -1) {
        	ListForm->ListFiles->Strings[j] = Caption;
        	ListForm->DrawFrame(j, (int)clBlue);
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Delete1Click(TObject *Sender)
{
    int i, Result;
    char *ptr;
    char DelFile[256 + 2];
    SHFILEOPSTRUCT SHFileOp;

    if (PathName == Caption) {
    	ViewForm = this;

		DeReForm = new TDeReForm (this);

    	DeReForm->Tag = 1;
    	DeReForm->Label2->Visible = false;
    	DeReForm->Label1->Top = 18;
    	DeReForm->Label5->Top = 18;
		DeReForm->Label5->Caption = PathName;
    	DeReForm->Edit1->Text = Caption;
        DeReForm->Caption = "C[W̍폜";
    	DeReForm->Label1->Caption = "Full Name  : ";
        DeReForm->Label3->Caption = "      Name :";
        DeReForm->Label4->Caption = "̃C[W폜܂H";

    	DeReForm->ClientWidth = DeReForm->Label5->Width + 90;
    	if (DeReForm->ClientWidth < 320)
    		DeReForm->ClientWidth = 320;
    	else if (DeReForm->ClientWidth > 600)
    		DeReForm->ClientWidth = 600;

    	Result = DeReForm->ShowModal();
    	delete DeReForm;
    }
    else {
        strcpy(DelFile, PathName.c_str());
        ptr = strchr(DelFile, '\0');
        *(ptr + 1) = '\0';

        SHFileOp.hwnd = FrameForm->Handle;
        SHFileOp.wFunc = FO_DELETE;
        SHFileOp.pFrom = DelFile;
        SHFileOp.pTo = NULL;
        SHFileOp.fFlags = FOF_ALLOWUNDO;
        SHFileOp.fAnyOperationsAborted = NULL;
        SHFileOp.hNameMappings = NULL;
        SHFileOp.lpszProgressTitle = NULL;

        Result = SHFileOperation(&SHFileOp);

        if (Result == 0 && SHFileOp.fAnyOperationsAborted == 0)
        	Result = mrYes;
        else {
        	Result = mrNo;
        }
    }

    if (Result == mrYes) {
    	if (FrameForm->ListSetting && ListChild) {
        	i = ListForm->ListFiles->IndexOf(Caption);
            if (i != -1) {
            	ListForm->ListIndex->Strings[i] = "-";
                ListForm->RemakeList();
            }
        }
        else if (PathName == Caption) {
        	Modefied = false;
        }

    	Close();
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::NewImage(const AnsiString ImageName, int width, int height, TColor color)
{
    bool stretch;
    int count;

    stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;

	PathName = ImageName;
    Caption = PathName;

    try {
    	if (width < height) {
    		Image1->Width = width;
    		Image1->Height = height;

    		Image1->Picture->Bitmap->Width = width;
    		Image1->Picture->Bitmap->Height = height;
        }
        else {
    		Image1->Height = height;
            Image1->Width = width;

    		Image1->Picture->Bitmap->Height = height;
            Image1->Picture->Bitmap->Width = width;
        }
    }
    catch (...) {
    	ShowMessage("TCY傫ĐVKC[W쐬ł܂B");
        Image1->Width = OrgWidth;
        Image1->Height = OrgHeight;
        Close();
        return;
    }

    count = FrameForm->MDIChildCount;
    if (FrameForm->ListSetting)
    	count--;

    if (count == 1) {
    	FrameForm->ActiveSpeedBar();
    }

    if (Image1->Width < 104) {
    	ClientWidth = 104;
        ClientHeight = ClientWidth * Image1->Height / Image1->Width;
    }
    else {
    	ClientHeight = Image1->Height;
        ClientWidth = Image1->Width;
    }

    Image1->Canvas->Brush->Color = color;
    Image1->Canvas->FillRect(Rect(0, 0, width, height));
    Image1->Canvas->Brush->Color = clWhite;

    NewImageColor = color;

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
     + " * " + IntToStr(Image1->Height);
    FrameForm->StatusBar1->Panels->Items[1]->Text = "";
	FrameForm->StatusBar1->Panels->Items[4]->Text = PathName;

    RealWidth = Image1->Width;
    RealHeight = Image1->Height;
    OrgWidth = RealWidth;
    OrgHeight = RealHeight;

    Tag = 0;
    AutoScroll = true;

    FrameForm->Stretch = stretch;

    StoreUndoBitmap(true);		// ύXÕC[WۑĂ
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::New1Click(TObject *Sender)
{
	FrameForm->New1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    int count;

    if (Caption == "Untitled")
    	return;

    if (Modefied || Image1->Width != RealWidth || Image1->Height != RealHeight) {
        if(MessageDlg(Caption + " ͕ύXĂ܂Bۑ܂H",
    	 mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0) == mrYes) {
        	Save1Click(Sender);
        }
    }

    count = FrameForm->MDIChildCount;
    if (FrameForm->ListSetting)
    	count--;

	if (count == 1) {
    	FrameForm->DeactiveSpeedBar();

    	if (FrameForm->Stretch)
            Stretch1Click(Sender);

        if (FrameForm->TextSetting)
        	Text1Click(Sender);
        else if (FrameForm->AreaSetting)
        	Areasetting1Click(Sender);

        if (FrameForm->ROverView) {
            OverViewForm->Image1->Canvas->Brush->Color = clBtnFace;
        	OverViewForm->Image1->Canvas->FillRect(Rect(0, 0,
             OverViewForm->Image1->Width, OverViewForm->Image1->Height));
        }

        FrameForm->StatusBar1->Panels->Items[0]->Text = "";
        FrameForm->StatusBar1->Panels->Items[1]->Text = "";
        FrameForm->StatusBar1->Panels->Items[4]->Text = "";
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormDeactivate(TObject *Sender)
{
	ViewForm = this;

    if (FrameForm->TimerOn)
    	return;

    if (FrameForm->AreaSetting)
        ClearArea();
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Areasetting1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {       // łɔ͈͎w肳Ăꍇ
        if (FrameForm->TextSetting) {
        	FrameForm->SpeedButton15->Down = true;
        	return;
        }
        ClearArea();
        FrameForm->AreaSetting = false;
        Areasetting1->Checked = false;
        FrameForm->SpeedButton15->Down = false;
        FrameForm->SpeedButton17->Enabled = false;
        Areacolor1->Enabled = false;
        FrameForm->StatusBar1->Panels->Items[2]->Text = "";
    	FrameForm->StatusBar1->Panels->Items[3]->Text = "";

        if (FrameForm->ROverView)
    		OverViewForm->DrawOverView();
    }
    else {
        if (FrameForm->Stretch)
        	Stretch1Click(Sender);
        if (FrameForm->DrawSetting)
        	FrameForm->DrawSettingOff();	// FrameForm->DrawSetting  false ɂ
        FrameForm->AreaSetting = true;
        Areasetting1->Checked = true;
        FrameForm->SpeedButton15->Down = true;
        FrameForm->SpeedButton17->Enabled = true;
        Areacolor1->Enabled = true;
        DrawArea();
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::DrawArea(void)
{
    int alx, aly, arx, ary;

    if (Draw || Tag == 2)
    	return;

    Arx = Alx + FrameForm->Awidth - 1;
    Ary = Aly + FrameForm->Aheight - 1;

    if (Arx > Image1->Width - 1) {
        Arx = Image1->Width - 1;
        Alx = Arx - FrameForm->Awidth + 1;
        if (Alx < 0) {
            Alx = 0;
            FrameForm->Awidth = Arx - Alx + 1;
        }
    }

    if (Ary > Image1->Height - 1) {
        Ary = Image1->Height - 1;
        Aly = Ary - FrameForm->Aheight + 1;
        if (Aly < 0) {
            Aly = 0;
            FrameForm->Aheight = Ary - Aly + 1;
        }
    }

	alx = Alx * OrgWidth / Image1->Width;
    aly = Aly * OrgHeight / Image1->Height;
    arx = Arx * OrgWidth / Image1->Width;
    ary = Ary * OrgHeight / Image1->Height;

    FrameForm->Abitmap->Width = arx - alx + 1;
    FrameForm->Abitmap->Height = ary - aly + 1;

    FrameForm->Abitmap->Canvas->CopyRect(Rect(0, 0, arx - alx, ary - aly),
     Image1->Canvas, Rect(alx, aly, arx, ary));

    Image1->Canvas->Pen->Color = (TColor)(FrameForm->AreaColor);
    Image1->Canvas->Pen->Width = 2;
    Image1->Canvas->Pen->Style = psSolid;
    Image1->Canvas->Brush->Style = bsClear;
	Image1->Canvas->Rectangle(alx + 1, aly + 1, arx, ary);

    FrameForm->StatusBar1->Panels->Items[2]->Text = IntToStr(FrameForm->Awidth)
     + " * " + IntToStr(FrameForm->Aheight);

    FrameForm->StatusBar1->Panels->Items[3]->Text = "\(" + IntToStr(Alx) + "\, "
	 + IntToStr(Aly) + "\)";

    Draw = true;

    if (FrameForm->ROverView && FrameForm->TextSetting == false)
    	OverViewForm->DrawOverView();
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::ClearArea(void)
{
	int alx, aly, arx,ary;

    if (Tag == 2)
    	return;

    alx = Alx * OrgWidth / Image1->Width;
    aly = Aly * OrgHeight / Image1->Height;
    arx = Arx * OrgWidth / Image1->Width;
    ary = Ary * OrgHeight / Image1->Height;

    Image1->Canvas->StretchDraw(Rect(alx, aly, arx, ary), FrameForm->Abitmap);

    Draw = false;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Copytoclipboard1Click(TObject *Sender)
{
    int width, height;
    Graphics::TBitmap *bitmap;
    Graphics::TBitmap *bitmap2;

	if (FrameForm->TextSetting)
    	return;

    bitmap = new Graphics::TBitmap;

    if (FrameForm->AreaSetting) {
        bitmap2 = new Graphics::TBitmap;

        width = Image1->Width;
        height = Image1->Height;

        bitmap2->Width = width;
        bitmap2->Height = height;

        ClearArea();

        bitmap2->Canvas->StretchDraw(Rect(0, 0, width, height),
         Image1->Picture->Bitmap);

        DrawArea();

        width = Arx - Alx + 1;
        height = Ary - Aly + 1;

        bitmap->Width = width;
        bitmap->Height = height;

        bitmap->Canvas->CopyRect(Rect(0, 0, width, height), bitmap2->Canvas,
         Rect(Alx, Aly, Arx, Ary));

        delete bitmap2;
    }
    else {
        width = Image1->Width;
        height = Image1->Height;

        bitmap->Width = width;
        bitmap->Height = height;

        bitmap->Canvas->StretchDraw(Rect(0, 0, width, height),
         Image1->Picture->Bitmap);
    }

    Clipboard()->Assign(bitmap);

    delete bitmap;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Cuttoclipboard1Click(TObject *Sender)
{
    int alx, aly, arx, ary;
	int width, height;
    Graphics::TBitmap *bitmap;

    if (FrameForm->TextSetting)
    	return;

    alx = Alx * OrgWidth / Image1->Width;
    aly = Aly * OrgHeight / Image1->Height;
    arx = Arx * OrgWidth / Image1->Width;
    ary = Ary * OrgHeight / Image1->Height;

    Image1->Canvas->Pen->Color = clBlack;
    Image1->Canvas->Pen->Style = psSolid;
    Image1->Canvas->Brush->Color = clBlack;
    Image1->Canvas->Brush->Style = bsSolid;

    bitmap = new Graphics::TBitmap;

    if (FrameForm->AreaSetting) {
        width = Arx - Alx + 1;
        height = Ary - Aly + 1;

        bitmap->Width = width;
        bitmap->Height = height;

        ClearArea();

        bitmap->Canvas->CopyRect(Rect(0, 0, width, height), Image1->Canvas,
         Rect(alx, aly, arx, ary));

        Image1->Canvas->Rectangle(alx + 1, aly + 1, arx, ary);

        DrawArea();
    }
    else {
        width = Image1->Width;
        height = Image1->Height;

        bitmap->Width = width;
        bitmap->Height = height;

        bitmap->Canvas->StretchDraw(Rect(0, 0, width, height),
         Image1->Picture->Bitmap);

        Image1->Canvas->Rectangle(0, 0, width, height);
    }

    Clipboard()->Assign(bitmap);

    delete bitmap;

    Modefied = true;
    StoreUndoData(true);
    StoreUndoBitmap(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Pastefromclipboard1Click(TObject *Sender)
{
	int alx, aly, arx,ary;
    int width, height;
    Graphics::TBitmap *bitmap;

    if (FrameForm->TextSetting)
    	return;

    bitmap = new Graphics::TBitmap;

    alx = Alx * OrgWidth / Image1->Width;
    aly = Aly * OrgHeight / Image1->Height;
    arx = Arx * OrgWidth / Image1->Width;
    ary = Ary * OrgHeight / Image1->Height;

    bitmap->Assign(Clipboard());

    if (FrameForm->AreaSetting) {
        Image1->Canvas->StretchDraw(Rect(alx, aly, arx, ary), bitmap);
    }
    else {
        width = bitmap->Width;
        height = bitmap->Height;

    	DrawArea();
		ClearArea();
/*
        Image1->Canvas->CopyRect(Rect(0, 0, width * OrgWidth / Image1->Width,
         height * OrgHeight / Image1->Height),
		 bitmap->Canvas, Rect(0, 0, width, height));
  */
        Image1->Canvas->StretchDraw(Rect(0, 0, width * OrgWidth / Image1->Width,
         height * OrgHeight / Image1->Height), bitmap);
    }

    Modefied = true;
    StoreUndoData(true);
    StoreUndoBitmap(true);

    if (FrameForm->AreaSetting) {
        Draw = false;
        DrawArea();
    }

    delete bitmap;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Text1Click(TObject *Sender)
{
    ViewForm = this;

    if (FrameForm->TextSetting) {       // łɃeLXg͐ݒ肳Ăꍇ
        TextForm->Close();
        Areasetting1Click(Sender);
    }
    else {
        if (FrameForm->AreaSetting == false)
        	Areasetting1Click(Sender);
        FrameForm->TextSetting = true;
        Text1->Checked = true;
        FrameForm->SpeedButton16->Down = true;

		TextForm = new TTextForm (Application);
    	TextForm->Show();
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Open2(const AnsiString FileName)
{
    bool stretch;
    bool ft;
    int count;
    int  width, height;
    Graphics::TBitmap *bitmap;
    UINT bufsize;
    LPBYTE buf;
    AnsiString LoadName;
    AnsiString LoadType;
    AnsiString Ext;
    AnsiString ShortName;
    TIcon *icon;
    HMETAFILE hMetaFile;
    HENHMETAFILE hEnhMetaFile;
    ENHMETAHEADER EnhMetaHeader;
    SHFILEINFO shfi;
    DWORD ilist;
    RECT rect;
    HANDLE handle;
    FILE_INFO FT;
    WIN32_FIND_DATA ffd;
    DWORD size;

    stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;

	PathName = FileName;
    Caption = ExtractFileName(PathName);
    Ext = ExtractFileExt(FileName);
    Ext = Ext.UpperCase();

    ft = false;

    if (Ext == ".BMP" || Ext == ".RLE") {
        bitmap = new Graphics::TBitmap;

        ft = true;
        try {
    		bitmap->LoadFromFile(PathName);
        }
        catch(...) {
        	ft = false;
        }

        if (ft) {
        	Image1->Picture->Bitmap->Width = bitmap->Width;
        	Image1->Picture->Bitmap->Height = bitmap->Height;

            Image1->Picture->Bitmap->Canvas->StretchDraw(Rect(0, 0,
             bitmap->Width, bitmap->Height), bitmap);

            Image1->Width = bitmap->Width;
            Image1->Height = bitmap->Height;
        }

        delete bitmap;
    }
    else if (Ext == ".JPG" || Ext == ".TIF") {
        ft = true;
        try {
        	ft = ImgKitFileType(PathName.c_str(), &FT);
        }
        catch(...) {
        	ft = false;
        }

        if (ft) {
        	LoadName = "Loading " + ExtractFileName(PathName);
            if (Ext == ".JPG")
            	LoadType = "JPEG";
            else
            	LoadType = "TIFF";

            try {
        		handle = ImgKitFileLoad(PathName.c_str(), LoadName.c_str(), LoadType.c_str());
            }
            catch(...) {
            	handle = 0;
            }

        	if (handle != 0) {
                try {
        			Image1->Width = FT.Width;
        			Image1->Height = FT.Height;

        			Image1->Picture->Bitmap->Width = FT.Width;
        			Image1->Picture->Bitmap->Height = FT.Height;

        			ImgKitDisplayHdc(Image1->Canvas->Handle, handle, FT.Width, FT.Height, false);
        			ImgKitMemFree(handle);
                }
                catch(...) {
                	ft = false;
                }
            }
            else
            	ft = false;
        }
    }
    else if (Ext == ".ICO") {
    	ft = true;
        handle = ::LoadImage(HInstance, PathName.c_str(), IMAGE_ICON, 0, 0,
         LR_DEFAULTCOLOR | LR_LOADFROMFILE);

        if (handle == NULL) {
        	ft = false;
        }
        else {
        	::FindFirstFile(PathName.c_str(), &ffd);

            size = ffd.nFileSizeLow;
            if (size > 766)
            	size = 48;
            else if (size > 318)
            	size = 32;
            else
            	size = 16;

            width = (int)size;
            height = (int)size;

        	Image1->Width = width;
            Image1->Height = height;

            Image1->Picture->Bitmap->Width = width;
            Image1->Picture->Bitmap->Height = height;

            Image1->Canvas->Pen->Color = Color;		// ViewForm ̃J[
            Image1->Canvas->Brush->Color = Color;	// ViewForm ̃J[
            Image1->Canvas->Brush->Style = bsSolid;
            Image1->Canvas->FillRect(Rect(0, 0, width, height));

            ::DrawIconEx(Image1->Canvas->Handle, 0, 0, handle, width, height,
             0, NULL, DI_NORMAL);

            ::CloseHandle(handle);
        }
    }
    else if (Ext == ".CUR") {
    	ft = true;
        handle = ::LoadImage(HInstance, PathName.c_str(), IMAGE_CURSOR, 0, 0,
         LR_DEFAULTCOLOR | LR_LOADFROMFILE);

         if (handle == NULL) {
        	ft = false;
        }
        else {
            width = 32;
            height = 32;

        	Image1->Width = width;
            Image1->Height = height;

            Image1->Picture->Bitmap->Width = width;
            Image1->Picture->Bitmap->Height = height;

            Image1->Canvas->Pen->Color = Color;		// ViewForm ̃J[
            Image1->Canvas->Brush->Color = Color;	// ViewForm ̃J[
            Image1->Canvas->Brush->Style = bsSolid;
            Image1->Canvas->FillRect(Rect(0, 0, width, height));

            ::DrawIconEx(Image1->Canvas->Handle, 0, 0, handle, width, height,
             0, NULL, DI_NORMAL);

            ::CloseHandle(handle);
        }
    }
    else if (Ext == ".WMF" || Ext == ".EMF") {
        ft = true;

        if (Ext == ".EMF") {
        	hEnhMetaFile = ::GetEnhMetaFile(PathName.c_str());
        }
        else {
        	ShortName = LongToShort(PathName);
        	hMetaFile = ::GetMetaFile(ShortName.c_str());
            bufsize = ::GetMetaFileBitsEx(hMetaFile, 0, NULL);
            buf = (LPBYTE)::GlobalAlloc(GPTR, bufsize);
            ::GetMetaFileBitsEx(hMetaFile, bufsize, buf);
            hEnhMetaFile = ::SetWinMetaFileBits(bufsize, buf,
             Image1->Canvas->Handle, NULL);
            ::GlobalFree(buf);
        }

        if (hEnhMetaFile == NULL) {
        	ft = false;
        }
        else {
            ::ZeroMemory(&EnhMetaHeader, sizeof(ENHMETAHEADER));

            ::GetEnhMetaFileHeader(hEnhMetaFile, sizeof(ENHMETAHEADER), &EnhMetaHeader);

            width = EnhMetaHeader.rclFrame.right - EnhMetaHeader.rclFrame.left + 1;
            height = EnhMetaHeader.rclFrame.bottom - EnhMetaHeader.rclFrame.top + 1;

            width = Screen->Width * width  / EnhMetaHeader.szlMillimeters.cx / 100;
            height = Screen->Height * height / EnhMetaHeader.szlMillimeters.cy / 100;

        	Image1->Width = width;
            Image1->Height = height;

            Image1->Picture->Bitmap->Width = width;
            Image1->Picture->Bitmap->Height = height;

            Image1->Canvas->Pen->Color = Color;		// ViewForm ̃J[
            Image1->Canvas->Brush->Color = Color;	// ViewForm ̃J[
            Image1->Canvas->Brush->Style = bsSolid;
            Image1->Canvas->FillRect(Rect(0, 0, width, height));

            rect.left = 0L;
            rect.right = (LONG)(width - 1);
            rect.top = 0L;
            rect.bottom = (LONG)(height - 1);

        	::PlayEnhMetaFile(Image1->Canvas->Handle, hEnhMetaFile, &rect);

            ::DeleteEnhMetaFile(hEnhMetaFile);
        }
    }
    else if (Ext == ".EXE" || Ext == ".DLL") {
        icon = new TIcon;

        ft = true;
        ilist = ::SHGetFileInfo(PathName.c_str(), FILE_ATTRIBUTE_ARCHIVE, &shfi,
         sizeof(SHFILEINFO), SHGFI_ICON | SHGFI_LARGEICON);

        if (ilist == 0) {
        	ft = false;
        }
        else {
    		icon->ReleaseHandle();
    		icon->Handle = shfi.hIcon;

            width = icon->Width;
            height = icon->Height;

        	Image1->Width = width;
            Image1->Height = height;

            Image1->Picture->Bitmap->Width = width;
            Image1->Picture->Bitmap->Height = height;

            Image1->Canvas->Pen->Color = Color;		// ViewForm ̃J[
            Image1->Canvas->Brush->Color = Color;	// ViewForm ̃J[
            Image1->Canvas->Brush->Style = bsSolid;
            Image1->Canvas->FillRect(Rect(0, 0, width, height));

            Image1->Canvas->Draw(0, 0, icon);
        }

        delete icon;
    }

    if (ft == false) {
        bitmap = new Graphics::TBitmap;

		ft = FrameForm->SusieView(PathName, bitmap);

        if (ft) {
        	Image1->Picture->Bitmap->Width = bitmap->Width;
        	Image1->Picture->Bitmap->Height = bitmap->Height;

            Image1->Picture->Bitmap->Canvas->StretchDraw(Rect(0, 0,
             bitmap->Width, bitmap->Height), bitmap);

            Image1->Width = bitmap->Width;
            Image1->Height = bitmap->Height;
        }

        delete bitmap;
    }

    if (ft == false) {
    	FrameForm->Stretch = stretch;
        ShowMessage("Can't open " + Caption);
        Tag = 2;
        Close();
        return;
    }
    else {
    	count = FrameForm->MDIChildCount;
    	if (FrameForm->ListSetting)
    	count--;

		if (count == 1) {
        	FrameForm->ActiveSpeedBar();
        }
    }

    if (Image1->Width < 104) {
    	ClientWidth = 104;
        ClientHeight = ClientWidth * Image1->Height / Image1->Width;
    }
    else {
    	ClientHeight = Image1->Height;
        ClientWidth = Image1->Width;
    }

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
     + " * " + IntToStr(Image1->Height);
    FrameForm->StatusBar1->Panels->Items[1]->Text = "";
	FrameForm->StatusBar1->Panels->Items[4]->Text = PathName;

    RealWidth = Image1->Width;
    RealHeight = Image1->Height;
    OrgWidth = RealWidth;
    OrgHeight = RealHeight;

    Tag = 0;
    AutoScroll = true;
    ListChild = true;

    FrameForm->Stretch = stretch;

    StoreUndoBitmap(true);		// ύXÕC[WۑĂ
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Copy1Click(TObject *Sender)
{
	int done;
    int rc, Result;
    struct ffblk ffb;
    AnsiString DestDir, DestFile;

    if (PathName == Caption)
    	return;

	DirectoryListForm = new TDirectoryListForm (this);

    DirectoryListForm->Caption = Caption + " ̃Rs[͂ĉB";

    Result = DirectoryListForm->ShowModal();

    DestDir = DirectoryListForm->DirectoryListBox1->Directory;
    if (DestDir.Length() > 3)
    	DestDir += "\\";

    DestFile = DestDir + Caption;

    delete DirectoryListForm;

    if (Result != mrOk)
    	return;

    if (PathName == DestFile) {
    	ShowMessage("tH_ɂ́ARs[o܂B");
    	return;
    }

    done = findfirst(DestFile.c_str(), &ffb,
     FA_ARCH | FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_DIREC);

    if (!done) {
    	rc = MessageDlg(Caption + " ́ARs[ɑ݂܂B㏑܂H",
         mtConfirmation, TMsgDlgButtons() << mbYes << mbNo, 0);

         if (rc == mrYes)
         	done = -1;
    }

    if (done) {
    	rc = CopyFile(PathName.c_str(), DestFile.c_str(), 0);
        if (rc == 0)
        	ShowMessage(Caption + " ́ARs[o܂B");
        else {
            if (DestDir.Length() > 3)
            	DestDir.SetLength(DestDir.Length() - 1);

        	ShowMessage(Caption + "  " + DestDir + " փRs[܂B");
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Move1Click(TObject *Sender)
{
	int i, done;
    int rc, Result;
    struct ffblk ffb;
    AnsiString DestDir, DestFile;

    if (PathName == Caption)
    	return;

	DirectoryListForm = new TDirectoryListForm (this);

    DirectoryListForm->Caption = Caption + " ̈ړ͂ĉB";

    Result = DirectoryListForm->ShowModal();

    DestDir = DirectoryListForm->DirectoryListBox1->Directory;
    if (DestDir.Length() > 3)
    	DestDir += "\\";

    DestFile = DestDir + Caption;

    delete DirectoryListForm;

    if (Result != mrOk)
    	return;

    if (PathName == DestFile) {
    	ShowMessage("tH_ɂ́Aړo܂B");
    	return;
    }

    if (PathName.SubString(1, 1) != DestFile.SubString(1, 1)) {
    	ShowMessage("قȂhCuԂł̃t@C̈ړ́Ao܂B");
        return;
    }

    done = findfirst(DestFile.c_str(), &ffb,
     FA_ARCH | FA_RDONLY | FA_HIDDEN | FA_SYSTEM | FA_DIREC);

    if (!done)
    	ShowMessage(Caption + " Ɠ̃t@Cړɑ݂܂̂ňړ͏o܂B");
    else {
    	rc = MoveFile(PathName.c_str(), DestFile.c_str());
        if (rc == 0)
        	ShowMessage(Caption + " ́Aړo܂B");
        else {
            if (DestDir.Length() > 3)
            	DestDir.SetLength(DestDir.Length() - 1);

        	ShowMessage(Caption + "  " + DestDir + " ֈړ܂B");

            if (FrameForm->ListSetting && ListChild) {
        		i = ListForm->ListFiles->IndexOf(Caption);
            	if (i != -1) {
            		ListForm->ListIndex->Strings[i] = "-";
                	ListForm->RemakeList();
            	}
        	}
            Close();
        }
    }

}
//---------------------------------------------------------------------------
void __fastcall TViewForm::View1Click(TObject *Sender)
{
    if (FrameForm->ListSetting)
    	View1->Checked = false;

	FrameForm->View1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Size1Click(TObject *Sender)
{
	FrameForm->Size1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Contrast1Click(TObject *Sender)
{
	if (FrameForm->AreaSetting) {
		HistgramBitmap(FrameForm->Abitmap);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		HistgramBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::HistgramBitmap(Graphics::TBitmap *bitmap)
{
    int result;
    int	x, y;
    int width, height;
    int	count, interval;
    int ratio;
    int pixel;
    int col, red, green, blue;
    int min, max;
    int colmap[256];
    bool hi;
    Graphics::TBitmap *bitmap2;

    ContrastForm = new TContrastForm (this);
    result = ContrastForm->ShowModal();

    max = ContrastForm->TrackBar1->Position;
    min = ContrastForm->TrackBar2->Position;

    delete ContrastForm;

    if (result != mrOk) {
    	FrameForm->TimerCancel = true;
    	return;
    }

    if (max == 0 && min == 0)
    	return;

    if (max > 0 || (max == 0 && min > 0))
    	hi = true;
    else
    	hi = false;

    if (hi)
        max = 255 - max;
    else {
    	max = 255 + max;
        min = -min;
    }

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;


    for (x = 0; x < 256; x++) {
		if (hi)
			col = (x - min) * 255 / (max - min);
		else
        	col = (x - min) * (max - min) / 255;

		if (col < 0)
        	col = 0;

		if (col > 255)
        	col = 255;

		colmap[x] = col;
	}

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
            if (FrameForm->TimerCancel)
        			break;

        	pixel = bitmap->Canvas->Pixels[x][y];
            red = pixel & 0x000000ff;				// Red
            red = colmap[red];
            green = (pixel & 0x0000ff00) >> 8;		// Green
            green = colmap[green];
            blue = (pixel & 0x00ff0000) >> 16;	// Blue
            blue = colmap[blue];

            pixel = red | (green << 8) | (blue << 16);

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Monochrome1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {
		EffectBitmap(FrameForm->Abitmap, 0);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		EffectBitmap(Image1->Picture->Bitmap, 0);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Red1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {
		EffectBitmap(FrameForm->Abitmap, 1);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		EffectBitmap(Image1->Picture->Bitmap, 1);

}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Blue1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {
		EffectBitmap(FrameForm->Abitmap, 2);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
	else
		EffectBitmap(Image1->Picture->Bitmap, 2);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Purple1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {
		EffectBitmap(FrameForm->Abitmap, 3);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		EffectBitmap(Image1->Picture->Bitmap, 3);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Bright1Click(TObject *Sender)
{
	if (FrameForm->AreaSetting) {
		BrightBitmap(FrameForm->Abitmap);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		BrightBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::BrightBitmap(Graphics::TBitmap *bitmap)
{
    int result;
    int	x, y;
    int width, height;
    int	count, interval;
    int ratio;
    int pixel;
    int red, green, blue;
    int bright;
    bool hi;
    Graphics::TBitmap *bitmap2;

    BrightForm = new TBrightForm (this);
    BrightForm->Effect = 0;
    result = BrightForm->ShowModal();

    bright = BrightForm->TrackBar1->Position;

    delete BrightForm;

    if (result != mrOk) {
    	FrameForm->TimerCancel = true;
    	return;
    }

    if (bright == 0)
    	return;

    if (bright > 0) {
        hi = true;
        bright += 100;
    }
    else {
    	hi = false;
        bright -= 100;
        bright = -bright;
    }

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
            if (FrameForm->TimerCancel)
        			break;

        	pixel = bitmap->Canvas->Pixels[x][y];
            red = pixel & 0x000000ff;				// Red
            green = (pixel & 0x0000ff00) >> 8;		// Green
            blue = (pixel & 0x00ff0000) >> 16;		// Blue

            if (hi) {
            	red = red * bright / 100;
                green = green * bright / 100;
                blue = blue * bright / 100;
            }
            else {
            	red = red * 100 / bright;
                green = green * 100 / bright;
                blue = blue * 100 / bright;
            }

            if (red > 255)
            	red = 255;
            else if (red < 0)
            	red = 0;

            if (green > 255)
            	green = 255;
            else if (green < 0)
            	green = 0;

            if (blue > 255)
            	blue = 255;
            else if (blue < 0)
            	blue = 0;

            pixel = red | (green << 8) | (blue << 16);

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::EdgeBitmap(Graphics::TBitmap *bitmap)
{
    int result;
    int	x, y;
    int xx, yy;
    int width, height;
    int	count, interval;
    int ratio;
    int pixel;
    int red, green, blue;
    int rr, gg, bb;
    int ro, go, bo;
    int edge;
    Graphics::TBitmap *bitmap2;

/*    int filter[9] = {
     0, -1,  0,
	-1,  5, -1,
     0, -1,  0};
*/
    BrightForm = new TBrightForm (this);
    BrightForm->Effect = 1;
    result = BrightForm->ShowModal();

    edge = BrightForm->TrackBar1->Position;

    delete BrightForm;

    if (result != mrOk) {
    	FrameForm->TimerCancel = true;
    	return;
    }

    if (edge == 0)
    	return;

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
            if (FrameForm->TimerCancel)
        			break;

            pixel = bitmap->Canvas->Pixels[x][y];

            if ((y > 0 && y < height - 1) && (x > 0 && x < width - 1)) {
            	ro = pixel & 0x000000ff;			// Red
            	go = (pixel & 0x0000ff00) >> 8;		// Green
            	bo = (pixel & 0x00ff0000) >> 16;	// Blue

            	rr = ro * 5;
            	gg = go * 5;
            	bb = bo * 5;

            	for(yy = -1; yy <= 1; yy++) {
            		for(xx = -1; xx <= 1; xx++) {
                    	if (abs(xx + yy) == 1) {
                			pixel = bitmap->Canvas->Pixels[x + xx][y + yy];
                			red = pixel & 0x000000ff;			// Red
                    		green = (pixel & 0x0000ff00) >> 8;	// Green
                    		blue = (pixel & 0x00ff0000) >> 16;	// Blue

                    		rr -= red;
                    		gg -= green;
                    		bb -= blue;
                    	}
					}
				}

                rr = ro + (rr - ro) * edge / 100;
            	if (rr > 255)
            		rr = 255;
            	else if (rr < 0)
            		rr = 0;

                gg = go + (gg - go) * edge / 100;
            	if (gg > 255)
            		gg = 255;
            	else if (gg < 0)
            		gg = 0;

                bb = bo + (bb - bo) * edge / 100;
            	if (bb > 255)
            		bb = 255;
            	else if (bb < 0)
            		bb = 0;

            	pixel = rr | (gg << 8) | (bb << 16);
            }

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Negative1Click(TObject *Sender)
{
	if (FrameForm->AreaSetting) {
		NegativeBitmap(FrameForm->Abitmap);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		NegativeBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::NegativeBitmap(Graphics::TBitmap *bitmap)
{
    int	x, y;
    int width, height;
    int	count, interval;
    int ratio;
    int pixel;
    Graphics::TBitmap *bitmap2;

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
            if (FrameForm->TimerCancel)
        			break;

        	pixel = bitmap->Canvas->Pixels[x][y];
            pixel = ~pixel & 0x00ffffff;

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Median1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {
		MedianBitmap(FrameForm->Abitmap);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		MedianBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::MedianBitmap(Graphics::TBitmap *bitmap)
{
    int result;
    int	i, j, x, y;
    int n, xx, yy, temp;
    int width, height;
    int	count, interval;
    int median;
    int ratio;
    int pixel, sum;
    int pixels[9];
    int sums[9];
    Graphics::TBitmap *bitmap2;

    BrightForm = new TBrightForm (this);
    BrightForm->Effect = 3;
    result = BrightForm->ShowModal();

    median = BrightForm->TrackBar1->Position;

    delete BrightForm;

    if (result != mrOk) {
    	FrameForm->TimerCancel = true;
    	return;
    }

    median = 100 - median;
    median = median * 255 / 100;

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
            if (FrameForm->TimerCancel)
        			break;

            pixel = bitmap->Canvas->Pixels[x][y];
            sum = pixel & 0x000000ff;			// Red
            sum += (pixel & 0x0000ff00) >> 8;	// Green
            sum += (pixel & 0x00ff0000) >> 16;	// Blue

            n = 0;
            for (yy = y - 1; yy <= y + 1; yy++) {
            	for (xx = x - 1; xx <= x + 1; xx++) {
                	if ((xx >= 0 && xx < width) && (yy >= 0 && yy < height)) {
        				pixels[n] = bitmap->Canvas->Pixels[xx][yy];
            			sums[n] = pixels[n] & 0x000000ff;			// Red
            			sums[n] += (pixels[n] & 0x0000ff00) >> 8;	// Green
            			sums[n] += (pixels[n] & 0x00ff0000) >> 16;	// Blue
                        n++;
                    }
                }
            }

            for (j = 0; j <= n / 2; j++) {
            	for (i = j + 1; i < n; i++) {
                	if (sums[i] < sums[j]) {
                    	temp = sums[j];
                        sums[j] = sums[i];
                        sums[i] = temp;
                        temp = pixels[j];
                        pixels[j] = pixels[i];
                        pixels[i] = temp;
                    }
                }
            }
            j--;

            if (abs(sum - sums[j]) >= median)
            	pixel = pixels[j];

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Flat1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {
		FlatBitmap(FrameForm->Abitmap);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		FlatBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FlatBitmap(Graphics::TBitmap *bitmap)
{
    int	x, y, pixel;
    int n, xx, yy;
    int red, green, blue;
    int width, height;
    int	count, interval;
    int ratio;
    Graphics::TBitmap *bitmap2;

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
            if (FrameForm->TimerCancel)
        			break;

            n = 0;
            red = 0;
            green = 0;
            blue = 0;
            for (yy = y - 1; yy <= y + 1; yy++) {
            	for (xx = x - 1; xx <= x + 1; xx++) {
                	if ((xx >= 0 && xx < width) && (yy >= 0 && yy < height)) {
        				pixel = bitmap->Canvas->Pixels[xx][yy];
            			red += pixel & 0x000000ff;			// Red
            			green += (pixel & 0x0000ff00) >> 8;	// Green
            			blue += (pixel & 0x00ff0000) >> 16;	// Blue
                        n++;
                    }
                }
            }

            red /= n;
            green /= n;
            blue /= n;
            pixel = red | (green << 8) | (blue << 16);

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Mosaic1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {
		MosaicBitmap(FrameForm->Abitmap);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		MosaicBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::MosaicBitmap(Graphics::TBitmap *bitmap)
{
    int result;
    int	x, y, pixel;
    int xx, yy;
    int width, height;
    int	count, interval;
    int mosaic;
    int ratio;
    Graphics::TBitmap *bitmap2;

    BrightForm = new TBrightForm (this);
    BrightForm->Effect = 2;
    result = BrightForm->ShowModal();

    mosaic = BrightForm->TrackBar1->Position;

    delete BrightForm;

    if (result != mrOk) {
    	FrameForm->TimerCancel = true;
    	return;
    }

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / mosaic / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height / mosaic);
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)((height / mosaic)
         - ((height / mosaic) % interval));
    }

    TimerForm->Button1->Enabled = true;

    for (y = 0; y < height; y += mosaic) {
    	for (x = 0; x < width; x += mosaic) {
            if (FrameForm->TimerCancel)
        			break;

            pixel = bitmap->Canvas->Pixels[x][y];
            for (yy = y; yy < y + mosaic && yy < height; yy++) {
            	for (xx = x; xx < x + mosaic && xx < width; xx++)
                	bitmap2->Canvas->Pixels[xx][yy] = TColor(pixel);
            }
		}
        if (FrameForm->TimerCancel)
        	break;

        count ++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 * mosaic / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Posterisation1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {
		PosterBitmap(FrameForm->Abitmap);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		PosterBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::PosterBitmap(Graphics::TBitmap *bitmap)
{
    int result;
    int	x, y;
    int width, height;
    int	count, interval;
    int ratio;
    int n, term, range;
    int pixel;
    int red, green, blue;
    int poster;
    Graphics::TBitmap *bitmap2;

    BrightForm = new TBrightForm (this);
    BrightForm->Effect = 4;
    result = BrightForm->ShowModal();

    poster = BrightForm->TrackBar1->Position;

    delete BrightForm;

    if (result != mrOk) {
    	FrameForm->TimerCancel = true;
    	return;
    }

    n = 1;
    for (x = 0; x < poster; x++)
    	n <<= 1;

    term = 256 / n;
    range = 255 / (n - 1);

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
            if (FrameForm->TimerCancel)
        			break;

        	pixel = bitmap->Canvas->Pixels[x][y];
            red = (pixel & 0x000000ff) / term * range;			// Red
            green = ((pixel & 0x0000ff00) >> 8) / term * range;	// Green
            blue = ((pixel & 0x00ff0000) >> 16) / term * range;	// Blue

            pixel = red | (green << 8) | (blue << 16);

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Sobel1Click(TObject *Sender)
{
    int result;
    int sobel;

	BrightForm = new TBrightForm (this);
    BrightForm->Effect = 5;
    result = BrightForm->ShowModal();

    sobel = BrightForm->TrackBar1->Position;

    delete BrightForm;

    if (result != mrOk) {
    	FrameForm->TimerCancel = true;
    	return;
    }

    if (sobel == 0)
    	return;

    if (FrameForm->AreaSetting) {
		SobelBitmap(FrameForm->Abitmap, sobel, false);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		SobelBitmap(Image1->Picture->Bitmap, sobel, false);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::SobelBitmap(Graphics::TBitmap *bitmap, int sobel, bool sw)
{
    int i;
    int	x, y;
    int xx, yy;
    int width, height;
    int	count, interval;
    int ratio;
    int col;
    int pixel;
    int red, green, blue;
    int rh, gh, bh;
    int rv, gv, bv;
    int rr, gg, bb;
    Graphics::TBitmap *bitmap2;

	int filterh[9] = {				// ̃GbWo
    	1, 0, -1,
    	2, 0, -2,
		1, 0, -1};

	int filterv[9] = {				// c̃GbWo
    	 1,  2,  1,
    	 0,  0,  0,
		-1, -2, -1};

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;

    for (y = 1; y < height - 1; y++) {
    	for (x = 1; x < width - 1; x++) {
            if (FrameForm->TimerCancel)
            	break;

            rh = gh = bh = 0;
            rv = gv = bv = 0;
            i = 0;

            for(yy = -1; yy <= 1; yy++) {
            	for(xx = -1; xx <= 1; xx++) {
                	pixel = bitmap->Canvas->Pixels[x + xx][y + yy];
               		red = pixel & 0x000000ff;			// Red
                   	green = (pixel & 0x0000ff00) >> 8;	// Green
                   	blue = (pixel & 0x00ff0000) >> 16;	// Blue

                    rh += red * filterh[i];
                   	gh += green * filterh[i];
                   	bh += blue * filterh[i];

                    rv += red * filterv[i];
                   	gv += green * filterv[i];
                   	bv += blue * filterv[i];

                    i++;
				}
			}

            rr = (rh * rh + rv * rv) * sobel / 100;
            gg = (gh * gh + gv * gv) * sobel / 100;
            bb = (bh * bh + bv * bv) * sobel / 100;

            rr = sqrt(rr);
            if (rr > 255)
            	rr = 255;

            gg = sqrt(gg);
            if (gg > 255)
            	gg = 255;

            bb = sqrt(bb);
            if (bb > 255)
            	bb = 255;

            col = rr | gg | bb;
            col = 255 - col;
            pixel = col | (col << 8) | (col << 16);
            if (sw)
            	pixel &= bitmap->Canvas->Pixels[x][y];

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    for(x = 1; x < width - 1; x++) {
    	pixel = bitmap2->Canvas->Pixels[x][1];
        bitmap2->Canvas->Pixels[x][0] = TColor(pixel);
    	pixel = bitmap2->Canvas->Pixels[x][height - 2];
        bitmap2->Canvas->Pixels[x][height - 1] = TColor(pixel);
    }

    for(y = 0; y < height; y++) {
    	pixel = bitmap2->Canvas->Pixels[1][y];
        bitmap2->Canvas->Pixels[0][y] = TColor(pixel);
    	pixel = bitmap2->Canvas->Pixels[width - 2][y];
        bitmap2->Canvas->Pixels[width - 1][y] = TColor(pixel);
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::PaintSobel1Click(TObject *Sender)
{
    int result;
    int sobel;

	BrightForm = new TBrightForm (this);
    BrightForm->Effect = 6;
    result = BrightForm->ShowModal();

    sobel = BrightForm->TrackBar1->Position;

    delete BrightForm;

    if (result != mrOk) {
    	FrameForm->TimerCancel = true;
    	return;
    }

    if (sobel == 0)
    	return;

    if (FrameForm->AreaSetting) {
		SobelBitmap(FrameForm->Abitmap, sobel, true);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		SobelBitmap(Image1->Picture->Bitmap, sobel, true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Clearclipboard1Click(TObject *Sender)
{
	Clipboard()->Clear();
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Pastewithlocation1Click(TObject *Sender)
{
	int alx, aly;
    int width, height;
    Graphics::TBitmap *bitmap;

    if (FrameForm->AreaSetting == false || FrameForm->TextSetting == true )
    	return;

    bitmap = new Graphics::TBitmap;

    alx = Alx * OrgWidth / Image1->Width;
    aly = Aly * OrgHeight / Image1->Height;

    bitmap->Assign(Clipboard());

    width = bitmap->Width;
    height = bitmap->Height;

    ClearArea();

    Image1->Canvas->StretchDraw(Rect(alx, aly, alx + width * OrgWidth / Image1->Width,
     aly + height * OrgHeight / Image1->Height), bitmap);

    Modefied = true;
    StoreUndoData(true);
    StoreUndoBitmap(true);

    DrawArea();

    delete bitmap;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::StoreUndoBitmap(bool Save)
{
    bool chk;
    int width, height;

    if (FrameForm->ROverView && FrameForm->AreaSetting == false)
    	OverViewForm->DrawOverView();

    if (FrameForm->RCanUndo == false)
    	return;

	if (Save) {
    	width = Image1->Picture->Bitmap->Width;
    	height = Image1->Picture->Bitmap->Height;

		FrameForm->UndoBitmap->Width = width;
		FrameForm->UndoBitmap->Height = height;

    	FrameForm->UndoBitmap->Canvas->StretchDraw(Rect(0, 0, width, height),
     	 Image1->Picture->Bitmap);
    }

    FrameForm->UndoWidth = Image1->Width;
    FrameForm->UndoHeight = Image1->Height;
    FrameForm->UndoModefied = Modefied;

    chk = (FrameForm->UndoHandle == UndoHandle && FrameForm->UndoCount > 0);
    Undo1->Enabled = chk;
    FrameForm->SpeedButton47->Enabled = chk;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::StoreUndoData(bool Save)
{
    int i, count;
    bool err;
    AnsiString OldName, NewName;

    if (FrameForm->RCanUndo == false)
    	return;

    Image1->Update();

    if (FrameForm->UndoHandle != UndoHandle) {
    	FrameForm->UndoHandle = UndoHandle;
        FrameForm->InitUndoData();
    }

    err = false;
    count = FrameForm->UndoCount;

    if (count == MaxUndoCount) {
    	OldName = FrameForm->RTempDir + "\\Undo0.bmp";
        DeleteFile(OldName.c_str());

        for (i = 0; i < MaxUndoCount - 1; i++) {
        	NewName = OldName;
            OldName = FrameForm->RTempDir + "\\Undo" + IntToStr(i + 1) + ".bmp";
            MoveFile(OldName.c_str(), NewName.c_str());
            FrameForm->Undo[i] = FrameForm->Undo[i + 1];
        }

        count--;
    }

    FrameForm->Undo[count].Width = FrameForm->UndoWidth;
    FrameForm->Undo[count].Height = FrameForm->UndoHeight;
    FrameForm->Undo[count].Save = Save;
    FrameForm->Undo[count].Modefied = FrameForm->UndoModefied;

    if (Save) {
    	NewName = FrameForm->RTempDir + "\\Undo" + IntToStr(count) + ".bmp";

        for (i = 0; i < 5; i++) {
            err = false;
        	Sleep(100);
        	try {
        		FrameForm->UndoBitmap->SaveToFile(NewName);
        	}
        	catch (...) {
        		err = true;
        	}
            if (!err)
            	break;
        }
    }

    if (!err) {
    	count++;
    	FrameForm->UndoCount = count;
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::RestoreUndoData(TObject *Sender)
{
    int i, count;
    bool err;
    AnsiString FileName;
    Graphics::TBitmap *bitmap;
    bool areasetting;
    bool textsetting;
    bool stretch;

    if (FrameForm->RCanUndo == false)
    	return;

    if (FrameForm->UndoHandle != UndoHandle || FrameForm->UndoCount == 0)
    	return;

    if (FrameForm->ListSetting) {
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    if (WindowState == wsMaximized)
    	WindowState = wsNormal;

    areasetting = FrameForm->AreaSetting;
    textsetting = FrameForm->TextSetting;

    if (textsetting)
    	Text1Click(Sender);
    else if (areasetting)
    	Areasetting1Click(Sender);

    err = false;
    FrameForm->StatusBar1->Panels->Items[1]->Text = "";
    stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;
    AutoScroll = false;

    Image1->AutoSize = false;
    Image1->Stretch = true;

    count = FrameForm->UndoCount;
    count--;

    if (FrameForm->Undo[count].Save) {
        bitmap = new Graphics::TBitmap;

    	FileName = FrameForm->RTempDir + "\\Undo" + IntToStr(count) + ".bmp";

        for (i = 0; i < 5; i++) {
        	err = false;
        	Sleep(100);
        	try {
        		bitmap->LoadFromFile(FileName);
        	}
        	catch (...) {
        		err = true;
        	}
            if (!err)
            	break;
        }

        if (!err) {
        	Image1->Picture->Bitmap->Width = bitmap->Width;
        	Image1->Picture->Bitmap->Height = bitmap->Height;

            Image1->Picture->Bitmap->Canvas->StretchDraw(Rect(0, 0,
             bitmap->Width, bitmap->Height), bitmap);

        	OrgWidth = FrameForm->Undo[count].Width;
        	OrgHeight = FrameForm->Undo[count].Height;
        }

        delete bitmap;
    }

    if (!err) {
    	Image1->Width = FrameForm->Undo[count].Width;
    	Image1->Height = FrameForm->Undo[count].Height;
    	Modefied = FrameForm->Undo[count].Modefied;

    	ClientWidth = Image1->Width;
    	ClientHeight = Image1->Height;
    }

    FrameForm->UndoCount = count;

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
     + " * " + IntToStr(Image1->Height);

    AutoScroll = true;
    FrameForm->Stretch = stretch;

    StoreUndoBitmap(true);

    Image1->Update();

    if (textsetting)
    	Text1Click(Sender);
    else if (areasetting)
    	Areasetting1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Image1MouseUp(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
    int x, y;

	if (!Active || FrameForm->TimerOn)
    	return;

    x = X * OrgWidth / Image1->Width;
	y = Y * OrgHeight / Image1->Height;

	if (FrameForm->Drawing) {
        if (FrameForm->DrawTool < 54) {	// AlpApۂ̎lpA~Aȉ~̏ꍇ
        	Image1->Canvas->Brush->Color = FrameForm->DrawInColor;
            if (FrameForm->DrawIn)
        		Image1->Canvas->Brush->Style = bsSolid;
        	else
        		Image1->Canvas->Brush->Style = bsClear;

            Image1->Canvas->Pen->Color = FrameForm->DrawColor;
            Image1->Canvas->Pen->Style = psSolid;

        	DrawShape(FrameForm->OriginPt, Point(x, y), pmCopy);

            SetDrawColor();
        }
        else if (FrameForm->DrawTool == 57) {	// ʂԂ̏ꍇ
        	DrawObje(FrameForm->OriginPt, false);
            FrameForm->DrawTool = 57;
            FrameForm->SpeedButton57->Down = true;
            FrameForm->UpDown1->Position = (short)(FrameForm->DrawWidth);
        }
        else if (FrameForm->DrawTool == 55 || FrameForm->DrawTool == 63) { // uVAS̏ꍇ
        	Image1->Canvas->Pen->Width = 1;
            DrawObje(Point(x, y), false);
        }

        FrameForm->Drawing = false;
        Modefied = true;
    	StoreUndoData(true);
    	StoreUndoBitmap(true);
    }

    FrameForm->StatusBar1->Panels->Items[1]->Text = "\(" + IntToStr(X) + "\, "
	 + IntToStr(Y) + "\)";
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::SetDrawColor(void)
{
    int	tool;

    tool = FrameForm->DrawTool;

    if (tool == 54 || tool == 55 || tool == 63) {	// _AuVAS
    	Image1->Canvas->Brush->Color = FrameForm->DrawColor;
        Image1->Canvas->Brush->Style = bsSolid;
    }
    else {
    	if (FrameForm->DrawTool < 54)	// AlpApۂ̎lpA~Aȉ~̏ꍇ
        	Image1->Canvas->Brush->Color = clBlack;
        else
    		Image1->Canvas->Brush->Color = FrameForm->DrawInColor;

        if (FrameForm->DrawIn)
        	Image1->Canvas->Brush->Style = bsSolid;
        else
        	Image1->Canvas->Brush->Style = bsClear;
	}

    if (FrameForm->DrawTool < 54)		// AlpApۂ̎lpA~Aȉ~̏ꍇ
    	Image1->Canvas->Pen->Color = clBlack;
    else
    	Image1->Canvas->Pen->Color = FrameForm->DrawColor;

    Image1->Canvas->Pen->Style = psSolid;

    if (tool == 54 || tool == 55 || tool == 57 || tool == 63) // _AuVAʂԂAS
    	Image1->Canvas->Pen->Width = 1;
    else
    	Image1->Canvas->Pen->Width = FrameForm->DrawWidth;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::DrawShape(TPoint TopLeft, TPoint BottomRight, TPenMode AMode)
{
	int lx, ly, rx, ry;
    int r;

    Image1->Canvas->Pen->Mode = AMode;

    lx = TopLeft.x;
    ly = TopLeft.y;
    rx = BottomRight.x;
    ry = BottomRight.y;

    switch (FrameForm->DrawTool) {
        case	49:				// lp
        	Image1->Canvas->Rectangle(lx, ly, rx, ry);
            break;
        case	50:				// pۂ̎lp
        	if (rx - lx < ry - ly)
            	r = (rx - lx) / 5;
            else
            	r = (ry - ly) / 5;
        	Image1->Canvas->RoundRect(lx, ly, rx, ry, r, r);
            break;
        case	51:				// ~
        	r = (rx - lx) * (rx - lx);
            r += (ry - ly) * (ry - ly);
            r = sqrt(r);
            lx -= r;
            ly -= r;
            rx = lx + r * 2;
            ry = ly + r * 2;
            Image1->Canvas->Ellipse(lx, ly, rx, ry);
            break;
        case	52:				// ȉ~
            Image1->Canvas->Ellipse(lx, ly, rx, ry);
            break;
    	case	53:				// 
        	Image1->Canvas->MoveTo(lx, ly);
            Image1->Canvas->LineTo(rx, ry);
        	break;
        default:
        	break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::DrawObje(TPoint Center, bool OnMoving)
{
    int x, y, r;

    x = Center.x;
    y = Center.y;
    r = (FrameForm->DrawWidth - 1) / 2;

    Image1->Canvas->Pen->Mode = pmCopy;

    switch (FrameForm->DrawTool) {
        case	54:				// _
        	if (r == 0)
        		Image1->Canvas->Pixels[x][y] = FrameForm->DrawColor;
            else
                Image1->Canvas->Ellipse(x - r, y - r, x + r, y + r);
            break;
        case	55:				// uV
        case	63:				// S
            if (OnMoving) {
            	Image1->Canvas->LineTo(x, y);
            }
            else {
            	if (r == 0)
        			Image1->Canvas->Pixels[x][y] = FrameForm->DrawColor;
            	else
                	Image1->Canvas->Ellipse(x - r, y - r, x + r, y + r);
            }
            break;
        case	56:				// Xv[
        	PaintSpray(Center);
            break;
        case	57:				// ʂԂ
            FrameForm->TimerOn = true;	// ʂԂłƂTC
            BaseColor = Image1->Canvas->Pixels[x][y];	// O[oϐ
        	PaintFill(Center);
            FrameForm->TimerOn = false;
            break;
		default:
        	break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::PaintSpray(TPoint Center)
{
	int i, r, count;
    int x, y, lx, ly;
    TColor color;

    r = 3 + FrameForm->DrawWidth / 2;
    count = r * r / 3;
    lx = Center.x - r;
    ly = Center.y - r;
    color = FrameForm->DrawColor;

    for (i = 0; i < count; i++) {
    	x = lx + rand() * r * 2 / RAND_MAX;
        y = ly + rand() * r * 2 / RAND_MAX;
        Image1->Canvas->Pixels[x][y] = color;
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::PaintFill(TPoint Center)
{
    int x, y;
    int sx, ex;
    int ssx, eex;
    bool found;
    TPoint Cse, StartEnd;

    if (BaseColor == FrameForm->DrawColor)
    	return;			// x[XJ[ƃh[J[ꍇȂ

    Cse = PaintLine(Center);
    ssx = Cse.x;
    eex = Cse.y;

    for (y = Center.y - 1; y >= 0; y--) {
    	found = false;
        sx = ssx;
        ex = eex;
        for (x = sx; x <= ex; x++) {
        	if (Image1->Canvas->Pixels[x][y] == BaseColor) {
                if (!found) {
            		StartEnd = PaintLine(Point(x, y));
                    if (StartEnd.y - StartEnd.x > 1) {
                    	ssx = StartEnd.x;		// ŏɃQbg[̍W
                    	eex = StartEnd.y;		// ŏɃQbgE[̍W
                    	found = true;
                    }
                    x = StartEnd.y;
                }
                else {
                	PaintFill(Point(x, y));	// ċA
                }
            }
        }

        if (!found)
        	break;

        if (y < Image1->Width - 1 && (ssx < sx || eex > ex)) {
        	for (x = ssx; x <= eex; x++) {
                if (x < sx || x > ex) {
            		if (Image1->Canvas->Pixels[x][y + 1] == BaseColor)
                		PaintFill(Point(x, y + 1));		// ċA
                }
            }
        }
    }

    ssx = Cse.x;
    eex = Cse.y;

    for (y = Center.y + 1; y < Image1->Height; y++) {
    	found = false;
        sx = ssx;
        ex = eex;
        for (x = sx; x <= ex; x++) {
        	if (Image1->Canvas->Pixels[x][y] == BaseColor) {
                if (!found) {
            		StartEnd = PaintLine(Point(x, y));
                    if (StartEnd.y - StartEnd.x > 1) {
                    	ssx = StartEnd.x;		// ŏɃQbg[̍W
                    	eex = StartEnd.y;		// ŏɃQbgE[̍W
                        found = true;
                    }
                    x = StartEnd.y;
                }
                else {
                	PaintFill(Point(x, y));	// ċA
                }
            }
        }

        if (!found)
        	break;

        if (y > 0 && (ssx < sx || eex > ex)) {
        	for (x = ssx; x <= eex; x++) {
            	if (x < sx || x > ex) {
            		if (Image1->Canvas->Pixels[x][y - 1] == BaseColor)
                		PaintFill(Point(x, y - 1));		// ċA
                }
            }
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::FormShow(TObject *Sender)
{
    if (FrameForm->DrawSetting) {
    	SetDrawColor();
    }
}
//---------------------------------------------------------------------------
TPoint __fastcall TViewForm::PaintLine(TPoint Center)
{
    int sx, ex, y;

    y = Center.y;

    for (sx = Center.x; sx >= 0; sx--) {
    	if (Image1->Canvas->Pixels[sx][y] != BaseColor)
        	break;
    }
    sx++;

    for (ex = Center.x + 1; ex < Image1->Width; ex++) {
    	if (Image1->Canvas->Pixels[ex][y] != BaseColor)
        	break;
    }
    ex--;

    if (ex - sx > 1) {
    	Image1->Canvas->MoveTo(sx, y);
        Image1->Canvas->LineTo(ex + 1, y);
//      Image1->Update();
    }

    return(Point(sx, ex));
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::RGBBitmap(Graphics::TBitmap *bitmap)
{
    int result;
    int	x, y;
    int width, height;
    int	count, interval;
    int ratio;
    int pixel;
    int red, green, blue;
    int redel, greenel, blueel;
    Graphics::TBitmap *bitmap2;

    RGBForm = new TRGBForm (this);
    result = RGBForm->ShowModal();

    redel = RGBForm->TrackBar1->Position;
    greenel = RGBForm->TrackBar2->Position;
    blueel = RGBForm->TrackBar3->Position;

    delete RGBForm;

    if (result != mrOk) {
    	FrameForm->TimerCancel = true;
    	return;
    }

    if (redel == 0 && greenel == 0 && blueel == 0)
    	return;

    width = bitmap->Width;
    height = bitmap->Height;

    bitmap2 = new Graphics::TBitmap;
    bitmap2->Width = width;
    bitmap2->Height = height;

    TimerForm = new TTimerForm (Application);
    TimerForm->Show();
    TimerForm->Caption = "Drawing " + Caption;

    count = 0;
    interval = height / 20;
    if (interval < 2) {
    	interval = 1;
        TimerForm->ProgressBar1->Step = 1;
        TimerForm->ProgressBar1->Max = (TProgressRange)height;
    }
    else {
        TimerForm->ProgressBar1->Step = (TProgressRange)interval;
        TimerForm->ProgressBar1->Max = (TProgressRange)(height - (height % interval));
    }

    TimerForm->Button1->Enabled = true;

    for (y = 0; y < height; y++) {
    	for (x = 0; x < width; x++) {
            if (FrameForm->TimerCancel)
        			break;

        	pixel = bitmap->Canvas->Pixels[x][y];
            red = pixel & 0x000000ff;				// Red
            green = (pixel & 0x0000ff00) >> 8;		// Green
            blue = (pixel & 0x00ff0000) >> 16;		// Blue

            red += redel;
            green += greenel;
            blue += blueel;

            if (red > 255)
            	red = 255;
            else if (red < 0)
            	red = 0;

            if (green > 255)
            	green = 255;
            else if (green < 0)
            	green = 0;

            if (blue > 255)
            	blue = 255;
            else if (blue < 0)
            	blue = 0;

            pixel = red | (green << 8) | (blue << 16);

			bitmap2->Canvas->Pixels[x][y] = TColor(pixel);
		}
        if (FrameForm->TimerCancel)
        	break;

        count++;
        if ((count % interval) == 0)
        	TimerForm->ProgressBar1->StepIt();

        ratio = count * 100 / height;
        TimerForm->Caption = "  " + IntToStr(ratio) + " %";

        Application->ProcessMessages();
	}
    if (FrameForm->TimerCancel) {
    	TimerForm->Close();
        delete bitmap2;
        return;
    }

    bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap2);

    TimerForm->Close();

    delete bitmap2;

    Modefied = true;
    StoreUndoData(true);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::RGB1Click(TObject *Sender)
{
	if (FrameForm->AreaSetting) {
		RGBBitmap(FrameForm->Abitmap);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		RGBBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Edge1Click(TObject *Sender)
{
    if (FrameForm->AreaSetting) {
		EdgeBitmap(FrameForm->Abitmap);
        ClearArea();

//        ViewForm->FormActivate(Sender);
    }
    else
		EdgeBitmap(Image1->Picture->Bitmap);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Reduce1Click(TObject *Sender)
{
    int  result;
    int  reduce;
    bool pallet;
    bool dither;
    bool areasetting;
    bool textsetting;
    AnsiString Reduce;
    LPSTR Lpstr;
    HANDLE ImageHandle;
    HANDLE NewHandle;
    int  InfoSize;
    int  ImageSize;

    areasetting = FrameForm->AreaSetting;
    textsetting = FrameForm->TextSetting;

    if (textsetting)
    	Text1Click(Sender);
    else if (areasetting)
    	Areasetting1Click(Sender);

	ReduceForm = new TReduceForm (this);

    result = ReduceForm->ShowModal();

    delete ReduceForm;

    if (result != mrOk) {
        if (textsetting)
    		Text1Click(Sender);
    	else if (areasetting)
    		Areasetting1Click(Sender);

    	return;
    }

    reduce = FrameForm->RReduceColor;
    pallet = FrameForm->RReducePallet;
    dither = FrameForm->RReduceDither;

    switch (reduce) {
    	case	1:
        	Reduce = "2l";
            break;
    	case	4:
        	Reduce = "16FJ[";
            break;
    	case	8:
        	Reduce = "256FJ[";
            break;
    	case	24:
        	Reduce = "1670FJ[";
            break;
    	default:
            reduce = 1;
            Reduce = "2l";
            break;
    }

    GetDIBSizes(Image1->Picture->Bitmap->Handle, InfoSize, ImageSize);
    ImageHandle = GlobalAlloc(GHND, InfoSize + ImageSize);
    if (ImageHandle == NULL) {
        if (textsetting)
        	Text1Click(Sender);
        else if (areasetting)
        	Areasetting1Click(Sender);

        return;
    }
    Lpstr = (LPSTR)GlobalLock(ImageHandle);
    GetDIB(Image1->Picture->Bitmap->Handle, Image1->Picture->Bitmap->Palette,
     (void *)Lpstr, (void *)(Lpstr + InfoSize));
    GlobalUnlock(ImageHandle);

    NewHandle = ImgKitConvertColor(ImageHandle, reduce, pallet, dither,
     "F̕ύX", Reduce.c_str());

    if (NewHandle == NULL) {
            if (textsetting)
        	Text1Click(Sender);
        else if (areasetting)
        	Areasetting1Click(Sender);

        return;
    }

    ImgKitDisplayHdc(Image1->Picture->Bitmap->Canvas->Handle, NewHandle,
     Image1->Picture->Bitmap->Width, Image1->Picture->Bitmap->Height, false);
    ImgKitMemFree(NewHandle);

	GlobalFree(ImageHandle);

    Image1->Height--;
    Image1->Height++;

    Modefied = true;
    StoreUndoData(true);
    StoreUndoBitmap(true);

    if (textsetting)
    	Text1Click(Sender);
    else if (areasetting)
    	Areasetting1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::SaveToIcon(const AnsiString SaveName)
{
    int	x, y;
    int	width, height;
    TIcon *icon;
    Graphics::TBitmap *bitmapm;
    Graphics::TBitmap *bitmapc;
    ICONINFO info;
    HICON iconh;

    icon = new TIcon;
    bitmapm = new Graphics::TBitmap;
    bitmapc = new Graphics::TBitmap;

    width = FrameForm->RIconSize;
    height = FrameForm->RIconSize;

    bitmapm->Monochrome = true;		// }XÑrbg}bv́AmN\
    bitmapm->Width = width;
    bitmapm->Height = height;

    bitmapm->Canvas->Pen->Color = clBlack;		// }XÑJ[
    bitmapm->Canvas->Brush->Color = clBlack;	// }XÑJ[
    bitmapm->Canvas->Brush->Style = bsSolid;
    bitmapm->Canvas->FillRect(Rect(0, 0, width, height));

    bitmapc->Width = width;
    bitmapc->Height = height;

    bitmapc->Canvas->StretchDraw(Rect(0, 0, width, height), Image1->Picture->Bitmap);

    for (y = 0; y < height; y++) {		// ACR̓ȕ̏
    	for (x = 0; x < width; x++) {
        	if (bitmapc->Canvas->Pixels[x][y] == Color) {	// ViewForm ̃J[
                bitmapm->Canvas->Pixels[x][y] = clWhite;	// ߐF
                bitmapc->Canvas->Pixels[x][y] = clBlack;	// ߐF
            }
        }
    }

    info.fIcon = TRUE;
    info.xHotspot = 0;
    info.yHotspot = 0;
    info.hbmMask = bitmapm->Handle;
    info.hbmColor = bitmapc->Handle;

    iconh = ::CreateIconIndirect(&info);

    icon->ReleaseHandle();
    icon->Handle = iconh;

    icon->SaveToFile(SaveName);

    delete bitmapc;
    delete bitmapm;
    delete icon;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TViewForm::LongToShort(const AnsiString PathName)
{
	AnsiString ShortName;
    char longname[MAX_PATH];
    char temp[16];
    char *ptr;
    WIN32_FIND_DATA ffd;

    ShortName = "";
    strcpy(longname, PathName.c_str());

    if (::FindFirstFile(longname, &ffd) == INVALID_HANDLE_VALUE) {
    	return(ShortName);
    }

    while (1) {
    	ptr = strrchr(longname, '\\');

        if (ptr != NULL) {
            strcpy(temp, "\\");
        	if (ffd.cAlternateFileName[0] == '\0')
            	strcat(temp, ffd.cFileName);
            else
            	strcat(temp, ffd.cAlternateFileName);
        	ShortName.Insert(temp, 1);
        }
        else {
        	ShortName.Insert(longname, 1);
            break;
        }

        *ptr = '\0';
        ::FindFirstFile(longname, &ffd);
    }

    return(ShortName);
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Triming(void)
{
    int left, up;
    int right, down;
    int width, height;
    bool stretch;
    Graphics::TBitmap *bitmap;

    try {
    	up = StrToInt(TrimForm->Panel2->Caption);
    	down = StrToInt(TrimForm->Panel3->Caption);
   		left = StrToInt(TrimForm->Panel4->Caption);
        right = StrToInt(TrimForm->Panel5->Caption);

    	width = Image1->Width - left - right;
    	height = Image1->Height - up - down;
    }
    catch(...) {
        ShowMessage("͒l܂B");
        return;
    }

    bitmap = new Graphics::TBitmap;

    bitmap->Width = width;
    bitmap->Height = height;
    bitmap->Canvas->CopyRect(Rect(0, 0, width, height), Image1->Canvas,
     Rect(left, up, left + width, up + height));

    FrameForm->StatusBar1->Panels->Items[1]->Text = "";
    stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;
    AutoScroll = false;

    Image1->AutoSize = false;
    Image1->Stretch = true;

    Image1->Picture->Bitmap->Width = width;
    Image1->Picture->Bitmap->Height = height;
    Image1->Width = width;
    Image1->Height = height;

    ClientWidth = width;
    ClientHeight = height;

    Image1->Picture->Bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap);

    OrgWidth = width;
    OrgHeight = height;
    Modefied = true;
    StoreUndoData(true);
    StoreUndoBitmap(true);

    delete bitmap;

    FrameForm->RTrimUp = up;
    FrameForm->RTrimDown = down;
    FrameForm->RTrimLeft = left;
    FrameForm->RTrimRight = right;

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
	 + " * " + IntToStr(Image1->Height);

    AutoScroll = true;
    FrameForm->Stretch = stretch;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::MakeBlank(void)
{
    int left, up;
    int right, down;
    int width, height;
    TColor color;
    bool stretch;
    Graphics::TBitmap *bitmap;

    try {
    	up = StrToInt(BlankForm->Panel2->Caption);
    	down = StrToInt(BlankForm->Panel3->Caption);
   		left = StrToInt(BlankForm->Panel4->Caption);
        right = StrToInt(BlankForm->Panel5->Caption);

    	width = left + Image1->Width + right;
    	height = up + Image1->Height + down;
    	color = BlankForm->Panel1->Color;
    }
    catch(...) {
        ShowMessage("͒l܂B");
        return;
    }

    bitmap = new Graphics::TBitmap;

    bitmap->Width = width;
    bitmap->Height = height;
    bitmap->Canvas->Pen->Color = color;
    bitmap->Canvas->Pen->Style = psSolid;
    bitmap->Canvas->Brush->Color = color;
    bitmap->Canvas->Brush->Style = bsSolid;
    bitmap->Canvas->Rectangle(0, 0, width + 1, height + 1);
    bitmap->Canvas->StretchDraw(Rect(left, up, left + Image1->Width, up + Image1->Height),
     Image1->Picture->Bitmap);

    FrameForm->StatusBar1->Panels->Items[1]->Text = "";
    stretch = FrameForm->Stretch;
    FrameForm->Stretch = false;
    AutoScroll = false;

    Image1->AutoSize = false;
    Image1->Stretch = true;

    Image1->Picture->Bitmap->Width = width;
    Image1->Picture->Bitmap->Height = height;
    Image1->Width = width;
    Image1->Height = height;

    ClientWidth = width;
    ClientHeight = height;

    Image1->Picture->Bitmap->Canvas->StretchDraw(Rect(0, 0, width, height), bitmap);

    OrgWidth = width;
    OrgHeight = height;
    Modefied = true;
    StoreUndoData(true);
    StoreUndoBitmap(true);

    delete bitmap;

    FrameForm->RBlankUp = up;
    FrameForm->RBlankDown = down;
    FrameForm->RBlankLeft = left;
    FrameForm->RBlankRight = right;
    FrameForm->RBlankColor = (int)color;

    FrameForm->StatusBar1->Panels->Items[0]->Text = IntToStr(Image1->Width)
	 + " * " + IntToStr(Image1->Height);

    AutoScroll = true;
    FrameForm->Stretch = stretch;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Areacolor1Click(TObject *Sender)
{
	int col[] = {clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal,
    				clGray, clSilver, clRed, clLime, clYellow, clBlue, clFuchsia,
                    clAqua, clWhite};

	FrameForm->ACIndex++;
    if (FrameForm->ACIndex == 16)
    	FrameForm->ACIndex = 0;

    FrameForm->AreaColor = col[FrameForm->ACIndex];
    TextForm->DrawRing();
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::MakeBlank1Click(TObject *Sender)
{
    if (FrameForm->ListSetting) {
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    if (WindowState == wsMaximized)
    	WindowState = wsNormal;

    if (FrameForm->TextSetting)
    	Text1Click(Sender);
    else if (FrameForm->AreaSetting)
    	Areasetting1Click(Sender);

	BlankForm = new TBlankForm (this);

    BlankForm->ShowModal();

    delete BlankForm;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Triming1Click(TObject *Sender)
{
    if (Image1->Width < 4 || Image1->Height < 4 ||
       (Image1->Width == 4 && Image1->Height == 4)) {
    	ShowMessage("̃TCỶ摜́Ag~Oo܂B");
        return;
    }

    if (FrameForm->ListSetting) {
    	if (ListForm->WindowState == wsMaximized)
    		ListForm->WindowState = wsNormal;
    }

    if (WindowState == wsMaximized)
    	WindowState = wsNormal;

    if (FrameForm->TextSetting)
    	Text1Click(Sender);
    else if (FrameForm->AreaSetting)
    	Areasetting1Click(Sender);

	TrimForm = new TTrimForm (this);

    TrimForm->ShowModal();

    delete TrimForm;
}
//---------------------------------------------------------------------------
void __fastcall TViewForm::Undo1Click(TObject *Sender)
{
	RestoreUndoData(Sender);
}
//---------------------------------------------------------------------------
