//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Text.h"
#include "MdiView.h"
#include "MdiFrame.h"
#include "Color.h"
#include "OverView.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TTextForm *TextForm;
//---------------------------------------------------------------------------
__fastcall TTextForm::TTextForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
    FrameForm->AreaText = Edit1->Text;
    FrameForm->TextSetting = false;
    FrameForm->SpeedButton16->Down = false;
    ViewForm->Text1->Checked = false;
    FrameForm->SpeedButton18->Enabled = true;
    ViewForm->Copytoclipboard1->Enabled = true;
	FrameForm->SpeedButton19->Enabled = true;
    ViewForm->Cuttoclipboard1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::DrawText(void)
{
	int width, height;
    int alx, aly, arx,ary;

    width = FrameForm->Abitmap->Width;
    height = FrameForm->Abitmap->Height;
    FrameForm->Textbitmap->Width = width;
    FrameForm->Textbitmap->Height = height;

    FrameForm->Textbitmap->Canvas->StretchDraw(Rect(0, 0, width - 1, height - 1),
    	FrameForm->Abitmap);

    if (Edit1->Text != "")
    	FrameForm->Textbitmap->Canvas->TextOut(0, 0, Edit1->Text);

    alx = ViewForm->Alx * ViewForm->OrgWidth / ViewForm->Image1->Width;
    aly = ViewForm->Aly * ViewForm->OrgHeight / ViewForm->Image1->Height;
    arx = ViewForm->Arx * ViewForm->OrgWidth / ViewForm->Image1->Width;
    ary = ViewForm->Ary * ViewForm->OrgHeight / ViewForm->Image1->Height;

    ViewForm->Image1->Canvas->StretchDraw(Rect(alx, aly, arx, ary), FrameForm->Textbitmap);
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::DrawRing(void)
{
    int alx, aly, arx,ary;

    alx = ViewForm->Alx * ViewForm->OrgWidth / ViewForm->Image1->Width;
    aly = ViewForm->Aly * ViewForm->OrgHeight / ViewForm->Image1->Height;
    arx = ViewForm->Arx * ViewForm->OrgWidth / ViewForm->Image1->Width;
    ary = ViewForm->Ary * ViewForm->OrgHeight / ViewForm->Image1->Height;

    ViewForm->Image1->Canvas->Pen->Color = (TColor)(FrameForm->AreaColor);
    ViewForm->Image1->Canvas->Pen->Width = 2;
    ViewForm->Image1->Canvas->Pen->Style = psSolid;
    ViewForm->Image1->Canvas->Brush->Style = bsClear;
	ViewForm->Image1->Canvas->Rectangle(alx + 1, aly + 1, arx, ary);

    if (FrameForm->ROverView)
    	OverViewForm->DrawOverView();
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::FormDeactivate(TObject *Sender)
{
	ViewForm->ClearArea();
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::FormActivate(TObject *Sender)
{
	DrawText();
    DrawRing();
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::FormCreate(TObject *Sender)
{
	Edit1->Text = FrameForm->AreaText;
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::FormShow(TObject *Sender)
{
    LocatePanel();

	FrameForm->SpeedButton18->Enabled = false;
    ViewForm->Copytoclipboard1->Enabled = false;
	FrameForm->SpeedButton19->Enabled = false;
    ViewForm->Cuttoclipboard1->Enabled = false;

    Panel1->Color = FrameForm->Textbitmap->Canvas->Font->Color;
    if (FrameForm->Textbitmap->Canvas->Brush->Style == bsClear) {
        Panel2->Tag = 0;
        Panel2->Color = clBtnFace;
    }
    else {
        Panel2->Tag = 1;
        Panel2->Color = FrameForm->Textbitmap->Canvas->Brush->Color;
    }
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::Panel4MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
	if (Button == mbLeft) {
		Panel1->Color = clBlack;
    	FrameForm->Textbitmap->Canvas->Font->Color = clBlack;

    	Edit1Change(Sender);
    }
    else if (Button == mbRight) {
        FrameForm->ColorDialog1->Color = Panel1->Color;

		if (FrameForm->ColorDialog1->Execute()) {
    		Panel1->Color = FrameForm->ColorDialog1->Color;
        	FrameForm->Textbitmap->Canvas->Font->Color = Panel1->Color;

        	Edit1Change(Sender);
    	}
    }
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::Panel5MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
	if (Button == mbLeft) {
    	Panel2->Tag = 0;
    	Panel2->Color = clBtnFace;
    	FrameForm->Textbitmap->Canvas->Brush->Style = bsClear;

    	Edit1Change(Sender);
    }
    else if (Button == mbRight) {
    	FrameForm->ColorDialog1->Color = Panel2->Color;

		if (FrameForm->ColorDialog1->Execute()) {
        	Panel2->Tag = 1;
    		Panel2->Color = FrameForm->ColorDialog1->Color;
        	FrameForm->Textbitmap->Canvas->Brush->Style = TBrushStyle();
        	FrameForm->Textbitmap->Canvas->Brush->Color = Panel2->Color;
        	FrameForm->Textbitmap->Canvas->Brush->Style = bsSolid;

        	Edit1Change(Sender);
    	}
    }
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::Edit1Change(TObject *Sender)
{
	DrawText();
    DrawRing();
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::LocatePanel(void)
{
	Left = FrameForm->Left + 4 + 16;
	if (FrameForm->Panel2->Visible)
    	Left += FrameForm->Panel2->Width;

	Top = FrameForm->Top + FrameForm->Height - FrameForm->StatusBar1->Height
          - Height - 4;
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::Button1MouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
	DrawText();

    ViewForm->Modefied = true;
    ViewForm->StoreUndoData(true);
    ViewForm->StoreUndoBitmap(true);

    ViewForm->Draw = false;
    ViewForm->DrawArea();
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::Button2Click(TObject *Sender)
{
    ViewForm->Text1Click(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TTextForm::Button3Click(TObject *Sender)
{
	FrameForm->FontDialog1->Font = FrameForm->Textbitmap->Canvas->Font;

	if (FrameForm->FontDialog1->Execute()) {
    	FrameForm->Textbitmap->Canvas->Font = FrameForm->FontDialog1->Font;
        Panel1->Color = FrameForm->FontDialog1->Font->Color;
        FrameForm->Textbitmap->Canvas->Font->Color = Panel1->Color;

        if (Panel2->Tag == 0) {
        	FrameForm->Textbitmap->Canvas->Brush->Style = bsClear;
        }
        else {
        	FrameForm->Textbitmap->Canvas->Brush->Style = TBrushStyle();
        	FrameForm->Textbitmap->Canvas->Brush->Color = Panel2->Color;
        	FrameForm->Textbitmap->Canvas->Brush->Style = bsSolid;
        }

        Edit1Change(Sender);
    }
}
//---------------------------------------------------------------------------
