//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Triming.h"
#include "MdiView.h"
#include "OverView.h"
#include "MdiFrame.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TTrimForm *TrimForm;
//---------------------------------------------------------------------------
__fastcall TTrimForm::TTrimForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::InitTrimData(void)
{
    int width, height;

    Trup = FrameForm->RTrimUp;
    Trdown = FrameForm->RTrimDown;
    Trleft = FrameForm->RTrimLeft;
    Trright = FrameForm->RTrimRight;

    width = ViewForm->Image1->Width;
    height = ViewForm->Image1->Height;

	if (width < 64 || height < 64)
    	Trlinew = 1;
    else
    	Trlinew = 2;

	if (height - Trup - Trdown < 4) {
		Trup = 0;
        Trdown = 0;
    }

	if (width - Trleft - Trright < 4) {
		Trleft = 0;
        Trright = 0;
    }

    UpDown1->Max = (short)(height - 4);
    UpDown2->Max = (short)(height - 4);
    UpDown3->Max = (short)(width - 4);
    UpDown4->Max = (short)(width - 4);

    UpDown1->Position = (short)Trup;
    UpDown2->Position = (short)Trdown;
    UpDown3->Position = (short)Trleft;
    UpDown4->Position = (short)Trright;

    Panel2->Caption = IntToStr(Trup);
    Panel3->Caption = IntToStr(Trdown);
    Panel4->Caption = IntToStr(Trleft);
    Panel5->Caption = IntToStr(Trright);
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::FormShow(TObject *Sender)
{
    InitTrimData();
	ViewForm->Image1->Canvas->Pen->Color = clBlack;
    ViewForm->Image1->Canvas->Pen->Width = Trlinew;
	ViewForm->Image1->Canvas->Pen->Mode = pmNotXor;
    ViewForm->Image1->Canvas->Pen->Style = psSolid;
    ViewForm->Image1->Canvas->Brush->Style = bsClear;
    DrawTrimArea();
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::UpDown1Click(TObject *Sender, TUDBtnType Button)
{
    if (Button == btNext) {
    	if (ViewForm->Image1->Height - UpDown1->Position - Trdown < 4) {
        	UpDown1->Position--;
            return;
        }
    }

    DrawTrimArea();
    Trup = UpDown1->Position;
    DrawTrimArea();
	Panel2->Caption = IntToStr(Trup);
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::UpDown2Click(TObject *Sender, TUDBtnType Button)
{
    if (Button == btNext) {
    	if (ViewForm->Image1->Height - UpDown2->Position - Trup < 4) {
        	UpDown2->Position--;
            return;
        }
    }

    DrawTrimArea();
    Trdown = UpDown2->Position;
    DrawTrimArea();
	Panel3->Caption = IntToStr(Trdown);
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::UpDown3Click(TObject *Sender, TUDBtnType Button)
{
    if (Button == btNext) {
    	if (ViewForm->Image1->Width - UpDown3->Position - Trright < 4) {
        	UpDown3->Position--;
            return;
        }
    }

    DrawTrimArea();
    Trleft = UpDown3->Position;
    DrawTrimArea();
	Panel4->Caption = IntToStr(Trleft);
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::UpDown4Click(TObject *Sender, TUDBtnType Button)
{
    if (Button == btNext) {
    	if (ViewForm->Image1->Width - UpDown4->Position - Trleft < 4) {
        	UpDown4->Position--;
            return;
        }
    }

    DrawTrimArea();
    Trright = UpDown4->Position;
    DrawTrimArea();
	Panel5->Caption = IntToStr(Trright);
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	DrawTrimArea();
    ViewForm->Image1->Canvas->Pen->Mode = pmCopy;
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::DrawTrimArea(void)
{
    ViewForm->Image1->Canvas->Rectangle(Trleft, Trup,
     ViewForm->Image1->Width - Trright, ViewForm->Image1->Height - Trdown);

	if (FrameForm->ROverView)
    	OverViewForm->DrawOverView();
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::Panel2MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
    int trup;

    trup = Trup;

    if (Button == mbLeft) {
    	trup -= 10;
        if (trup < 0)
        	trup = 0;
    }
    else if (Button == mbRight) {
    	trup += 10;
        if (trup > UpDown1->Max)
        	trup = UpDown1->Max;
    }

    if (ViewForm->Image1->Height - trup - Trdown < 4)
        return;

    DrawTrimArea();
    Trup = trup;
    UpDown1->Position = (short)Trup;
    DrawTrimArea();
	Panel2->Caption = IntToStr(Trup);
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::Panel3MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
    int trdown;

    trdown = Trdown;

    if (Button == mbLeft) {
    	trdown -= 10;
        if (trdown < 0)
        	trdown = 0;
    }
    else if (Button == mbRight) {
    	trdown += 10;
        if (trdown > UpDown2->Max)
        	trdown = UpDown2->Max;
    }

    if (ViewForm->Image1->Height - trdown - Trup < 4)
        return;

    DrawTrimArea();
    Trdown = trdown;
    UpDown2->Position = (short)Trdown;
    DrawTrimArea();
	Panel3->Caption = IntToStr(Trdown);
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::Panel4MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
    int trleft;

    trleft = Trleft;

    if (Button == mbLeft) {
    	trleft -= 10;
        if (trleft < 0)
        	trleft = 0;
    }
    else if (Button == mbRight) {
    	trleft += 10;
        if (trleft > UpDown3->Max)
        	trleft = UpDown3->Max;
    }

    if (ViewForm->Image1->Width - trleft - Trright < 4)
        return;

    DrawTrimArea();
    Trleft = trleft;
    UpDown3->Position = (short)Trleft;
    DrawTrimArea();
	Panel4->Caption = IntToStr(Trleft);
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::Panel5MouseDown(TObject *Sender, TMouseButton Button,
	TShiftState Shift, int X, int Y)
{
    int trright;

    trright = Trright;

    if (Button == mbLeft) {
    	trright -= 10;
        if (trright < 0)
        	trright = 0;
    }
    else if (Button == mbRight) {
    	trright += 10;
        if (trright > UpDown1->Max)
        	trright = UpDown1->Max;
    }

    if (ViewForm->Image1->Width - trright - Trleft < 4)
        return;

    DrawTrimArea();
    Trright = trright;
    UpDown4->Position = (short)Trright;
    DrawTrimArea();
	Panel5->Caption = IntToStr(Trright);
}
//---------------------------------------------------------------------------
void __fastcall TTrimForm::Button1Click(TObject *Sender)
{
    if (Panel2->Caption == "0" && Panel3->Caption == "0" &&
     Panel4->Caption == "0" && Panel5->Caption == "0")
    	return;

	DrawTrimArea();
    ViewForm->Triming();

    if (SetTrimData() == false)
    	ModalResult = mrOk;

    DrawTrimArea();
}
//---------------------------------------------------------------------------
bool __fastcall TTrimForm::SetTrimData(void)
{
    int width, height;

    width = ViewForm->Image1->Width;
    height = ViewForm->Image1->Height;

    if (width < 4 || height < 4 || (width == 4 && height == 4))
        return(false);

	if (width < 64 || height < 64)
    	Trlinew = 1;
    else
    	Trlinew = 2;

    if (height - Trup - Trdown < 4) {
		Trup = 0;
        Trdown = 0;
    }

	if (width - Trleft - Trright < 4) {
		Trleft = 0;
        Trright = 0;
    }

    UpDown1->Max = (short)(height - 4);
    UpDown2->Max = (short)(height - 4);
    UpDown3->Max = (short)(width - 4);
    UpDown4->Max = (short)(width - 4);

    UpDown1->Position = (short)Trup;
    UpDown2->Position = (short)Trdown;
    UpDown3->Position = (short)Trleft;
    UpDown4->Position = (short)Trright;

    Panel2->Caption = IntToStr(Trup);
    Panel3->Caption = IntToStr(Trdown);
    Panel4->Caption = IntToStr(Trleft);
    Panel5->Caption = IntToStr(Trright);

    return(true);
}
//---------------------------------------------------------------------------
